package com.fastservice.app.activities;

import android.app.Activity;
import android.content.Context;
import android.graphics.Color;
import android.graphics.drawable.ColorDrawable;
import android.os.Bundle;
import android.view.MenuItem;
import android.widget.TextView;

import com.fastservice.app.R;

import java.io.BufferedReader;
import java.io.IOException;
import java.io.InputStream;
import java.io.InputStreamReader;

public class AyudaActivity extends Activity {

     @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.activity_ayuda);

        // enable ActionBar app icon to behave as action to toggle nav drawer
        getActionBar().setDisplayHomeAsUpEnabled(true);
        getActionBar().setHomeButtonEnabled(true);
        getActionBar().setBackgroundDrawable(new ColorDrawable(Color.parseColor("#ff800202")));
    }

    @Override
    protected void onResume() {
        super.onResume();
        setTitle("Ayuda");
        TextView ayuda = (TextView) findViewById(R.id.textoAyuda);
        ayuda.setText(leerFicheroDeAyuda(this,R.raw.ayuda));
    }

    @Override
    public boolean onOptionsItemSelected(MenuItem item) {
        switch (item.getItemId()) {
            case android.R.id.home:
                finish();
                return true;
            case R.id.action_settings:
                return true;
            default:
                return super.onOptionsItemSelected(item);
        }
    }

    public static String leerFicheroDeAyuda(Context context, int resId)
    {
        InputStream inputStream = context.getResources().openRawResource(resId);

        InputStreamReader inputreader = new InputStreamReader(inputStream);
        BufferedReader buffreader = new BufferedReader(inputreader);
        String linea;
        StringBuilder textoAyuda = new StringBuilder();

        try {
            while (( linea = buffreader.readLine()) != null) {
                textoAyuda.append(linea);
                textoAyuda.append('\n');
            }
        } catch (IOException e) {
            return null;
        }
        return textoAyuda.toString();
    }
}
