package com.fastservice.app.activities;

import android.app.Activity;
import android.content.Intent;
import android.graphics.Color;
import android.graphics.drawable.ColorDrawable;
import android.os.Bundle;
import android.support.v4.app.FragmentActivity;
import android.view.Menu;
import android.view.MenuItem;

import com.fastservice.app.R;
import com.fastservice.app.utils.Constants;

public class DetallesArticuloActivity extends FragmentActivity implements DetallesArticuloFragment.ListenerButtonDetalle {

    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.detalles_articulo_activity);


        // enable ActionBar app icon to behave as action to toggle nav drawer
        getActionBar().setDisplayHomeAsUpEnabled(true);
        getActionBar().setHomeButtonEnabled(true);
        getActionBar().setBackgroundDrawable(new ColorDrawable(Color.parseColor("#ff800202")));

        getActionBar().setTitle("Detalles del Articulo");
    }

    @Override
    protected void onResume() {
        super.onResume();
        setTitle("Detalles Articulo");

        Bundle extras = getIntent().getExtras();
        String idArticulo = extras.getString(Constants.Articulo_Seleccionado, null);
        if(idArticulo != null){
            //Si existe, se carga la interfaz, se busca el fragment y se actualiza con la oferta.
            DetallesArticuloFragment detalles = (DetallesArticuloFragment) getFragmentManager().findFragmentById(R.id.fragmentDetalle);
            detalles.visualizarDetalles(idArticulo);
        }
    }

    @Override
    public boolean onCreateOptionsMenu(Menu menu) {
        //MenuInflater inflater = getMenuInflater();
        //inflater.inflate(R.menu.detalles_articulo, menu);
        return super.onCreateOptionsMenu(menu);
    }

    @Override
    public boolean onOptionsItemSelected(MenuItem item) {
        // Handle action buttons
        switch (item.getItemId()) {
            case android.R.id.home:
                finish();
                return true;
            case R.id.action_settings:
                return true;
            default:
                return super.onOptionsItemSelected(item);
        }
    }

    @Override
    public void onButtonClick() {
            Intent intent=new Intent();
            intent.putExtra("aceptado","aceptado");
            setResult(Activity.RESULT_OK, intent);
            finish();
    }
}
