package com.fastservice.app.activities;

import android.app.Activity;
import android.app.Fragment;
import android.content.Context;
import android.graphics.Bitmap;
import android.graphics.BitmapFactory;
import android.os.AsyncTask;
import android.os.Bundle;
import android.util.Log;
import android.view.LayoutInflater;
import android.view.View;
import android.view.ViewGroup;
import android.widget.Button;
import android.widget.ImageView;
import android.widget.LinearLayout;
import android.widget.TextView;

import com.fastservice.app.R;
import com.fastservice.app.conections.BD;
import com.fastservice.app.utils.Constants;
import com.fastservice.app.utils.Utils;

import org.json.JSONException;
import org.json.JSONObject;

import java.io.InputStream;

public class DetallesArticuloFragment extends Fragment {


    private ListenerButtonDetalle mListener;
    private String idRestaurante = "";
    private Context context = this.getActivity();

    public DetallesArticuloFragment() {
        // Required empty public constructor
    }

    @Override
    public void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);

    }

    @Override
    public void onResume() {
        super.onResume();

    }

    @Override
    public View onCreateView(LayoutInflater inflater, ViewGroup container,
                             Bundle savedInstanceState) {
        // Inflate the layout for this fragment
        return inflater.inflate(R.layout.fragment_detalles_articulo, container, false);
    }

    public void visualizarDetalles(String plato){
        LinearLayout detalle = (LinearLayout) getView().findViewById(R.id.detalle);
        LinearLayout aviso = (LinearLayout) getView().findViewById(R.id.aviso);

        detalle.setVisibility(View.VISIBLE);
        aviso.setVisibility(View.GONE);

        TextView nombre = (TextView) getView().findViewById(R.id.nombre);
        TextView descripcion = (TextView) getView().findViewById(R.id.descripcion);
        TextView precio = (TextView) getView().findViewById(R.id.precio);
        try {
            BD bd;
            if (idRestaurante.equals("")){
                bd = new BD();
                JSONObject ticketAbierto = null;
                ticketAbierto = bd.obtenerTicketAbiertoDeUsuario(Utils.getLoggedUser(getActivity())).getJSONObject(0);
                if (ticketAbierto == null){
                    Utils.showTimeoutAlert(context);
                }
                else{
                    idRestaurante = ticketAbierto.getString("id_restaurante");
                }
            }
            bd = new BD();
            JSONObject articulo = null;
            articulo = bd.obtenerArticulosdeRestaurantePorNombre(idRestaurante,plato).getJSONObject(0);

            if (articulo == null){
                Utils.showTimeoutAlert(context);
            }
            else{
                nombre.setText(articulo.getString("nombre"));
                precio.setText(articulo.getString("precio")+" €");
                descripcion.setText(articulo.getString("descripcion"));

                bd = new BD();
                JSONObject img = bd.obtenerFotoDelArticulo(articulo.getString("foto")).getJSONObject(0);

                new DownloadImageTask((ImageView) getView().findViewById(R.id.imagen))
                        .execute(Constants.Servidor_Imagenes+img.getString("foto"));
            }

        } catch (JSONException e) {
            e.printStackTrace();
        }

        Button anadir = (Button) getView().findViewById(R.id.anadir);
        anadir.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View view) {
                mListener.onButtonClick();
            }
        });
    }

    private class DownloadImageTask extends AsyncTask<String, Void, Bitmap> {
        ImageView bmImage;

        public DownloadImageTask(ImageView bmImage) {
            this.bmImage = bmImage;
        }

        protected Bitmap doInBackground(String... urls) {
            String urldisplay = urls[0];
            Bitmap mIcon11 = null;
            try {
                InputStream in = new java.net.URL(urldisplay).openStream();
                mIcon11 = BitmapFactory.decodeStream(in);
            } catch (Exception e) {
                Log.e("Error", e.getMessage());
                e.printStackTrace();
            }
            return mIcon11;
        }

        protected void onPostExecute(Bitmap result) {
            bmImage.setImageBitmap(result);
        }
    }

    @Override
    public void onAttach(Activity activity) {
        super.onAttach(activity);
        try {
            mListener = (ListenerButtonDetalle) activity;
        } catch (ClassCastException e) {
            throw new ClassCastException(activity.toString()
                    + " must implement OnFragmentInteractionListener");
        }
    }

    @Override
    public void onDetach() {
        super.onDetach();
        mListener = null;
    }

    public interface ListenerButtonDetalle {
        public void onButtonClick();
    }

}
