package com.fastservice.app.activities;

import android.graphics.Color;
import android.graphics.drawable.ColorDrawable;
import android.os.Bundle;
import android.support.v4.app.FragmentActivity;
import android.view.Menu;
import android.view.MenuItem;

import com.fastservice.app.R;
import com.fastservice.app.utils.Constants;

public class DetallesHistorialActivity extends FragmentActivity {


    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.detalles_historial_activity);

        // enable ActionBar app icon to behave as action to toggle nav drawer
        getActionBar().setDisplayHomeAsUpEnabled(true);
        getActionBar().setHomeButtonEnabled(true);
        getActionBar().setBackgroundDrawable(new ColorDrawable(Color.parseColor("#ff800202")));

    }

    @Override
    protected void onResume() {
        super.onResume();
        setTitle("Detalles Pedido");
        Bundle extras = getIntent().getExtras();
        String idArticulo = extras.getString(Constants.Historial_Seleccionado, null);
        if(idArticulo != null){
            //Si existe, se carga la interfaz, se busca el fragment y se actualiza con la oferta.
            DetallesHistorialFragment detalles = (DetallesHistorialFragment) getFragmentManager().findFragmentById(R.id.fragment_detalle_historial);
            detalles.visualizarDetalles(idArticulo);
        }
    }

    @Override
    public boolean onCreateOptionsMenu(Menu menu) {
        //MenuInflater inflater = getMenuInflater();
        //inflater.inflate(R.menu.detalles_articulo, menu);
        return super.onCreateOptionsMenu(menu);
    }

    @Override
    public boolean onOptionsItemSelected(MenuItem item) {
        // Handle action buttons
        switch (item.getItemId()) {
            case android.R.id.home:
                finish();
                return true;
            case R.id.action_settings:
                return true;
            default:
                return super.onOptionsItemSelected(item);
        }
    }


/*    public void onActivityResult(int requestCode, int resultCode, Intent intent) {
        if (requestCode == IntentIntegrator.REQUEST_CODE) {
            if (resultCode != RESULT_CANCELED) {
                String contents = intent.getStringExtra("SCAN_RESULT");
                String format = intent.getStringExtra("SCAN_RESULT_FORMAT");
                Log.i("Correcto: ", contents);
                // Handle successful scan
                if (contents.contains("restaurante=") && contents.contains("mesa=")){
                    //Contents se recibe de la forma "restaurante=XXX&mesa=YYY"
                    String restaurante = contents.split("&")[0].split("=")[1];
                    String mesa = contents.split("&")[1].split("=")[1];
                    BD bd = new BD();
                    bd.crearTicket(Utils.getLoggedUser(this),restaurante,mesa);
                    Intent i = new Intent(DetallesHistorialActivity.this,PedidoActivity.class);
                    startActivity(i);
                    finish();
                }
                else{
                    Utils.showToast(this,"El codigo QR escaneado no corresponde a ningún restaurante.");
                }
            } else if (resultCode == RESULT_CANCELED) {
                // Handle cancel
                Log.i("Incorrecto: ",resultCode+"");
            }
        }
    }*/
}
