package com.fastservice.app.activities;

import android.app.Fragment;
import android.content.Context;
import android.graphics.Bitmap;
import android.graphics.BitmapFactory;
import android.os.AsyncTask;
import android.os.Bundle;
import android.util.Log;
import android.view.LayoutInflater;
import android.view.View;
import android.view.ViewGroup;
import android.widget.ImageView;
import android.widget.LinearLayout;
import android.widget.TextView;

import com.fastservice.app.R;
import com.fastservice.app.conections.BD;
import com.fastservice.app.utils.Constants;
import com.fastservice.app.utils.Utils;

import org.json.JSONArray;
import org.json.JSONException;
import org.json.JSONObject;

import java.io.InputStream;

public class DetallesHistorialFragment extends Fragment {

    private Context context = this.getActivity();
    public DetallesHistorialFragment() {
        // Required empty public constructor
    }

    @Override
    public void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
    }

    @Override
    public View onCreateView(LayoutInflater inflater, ViewGroup container,
                             Bundle savedInstanceState) {
        // Inflate the layout for this fragment
        return inflater.inflate(R.layout.fragment_detalles_historial, container, false);
    }

    @Override
    public void onResume() {
        super.onResume();
    }

    public void visualizarDetalles(String idTicket){
        LinearLayout detalle = (LinearLayout) getView().findViewById(R.id.detalle);
        LinearLayout aviso = (LinearLayout) getView().findViewById(R.id.aviso);

        detalle.setVisibility(View.VISIBLE);
        aviso.setVisibility(View.GONE);

        double precio = 0.0;
        TextView restaurante = (TextView) getView().findViewById(R.id.restaurante);
        TextView fecha = (TextView) getView().findViewById(R.id.fecha);
        TextView pedido = (TextView) getView().findViewById(R.id.pedido);
        TextView total = (TextView) getView().findViewById(R.id.total);
        try {
            BD bd = new BD();
            JSONObject ticket = null;
            ticket = bd.obtenerTicket(idTicket).getJSONObject(0);
            if (ticket == null){
                Utils.showTimeoutAlert(context);
            }
            else{
                String f = ticket.getString("fecha").substring(0,19);
                fecha.setText(f.split("T")[0] + " " + f.split("T")[1]);
                bd = new BD();
                JSONObject rest = bd.obtenerRestaurante(ticket.getString("id_restaurante")).getJSONObject(0);
                if (rest == null){
                    Utils.showTimeoutAlert(context);
                }
                else{
                    restaurante.setText("Restaurane: " + rest.getString("nombre"));

                    bd = new BD();
                    JSONObject img = bd.obtenerFotoDelArticulo(rest.getString("logo")).getJSONObject(0);
                    if (img == null){
                        Utils.showTimeoutAlert(context);
                    }
                    else{
                        new DownloadImageTask((ImageView) getView().findViewById(R.id.logo))
                                .execute(Constants.Servidor_Imagenes+img.getString("foto"));

                        pedido.setText("");
                        bd = new BD();
                        JSONArray articulos = bd.obtenerArticulosCartaTicket(idTicket);
                        if (articulos == null){
                            Utils.showTimeoutAlert(context);
                        }
                        else{
                            for (int i = 0; i < articulos.length(); i++){
                                JSONObject articulo = articulos.getJSONObject(i);
                                pedido.setText(pedido.getText()+articulo.getString("nombre")+"\n");
                                pedido.setText(pedido.getText()+"\t"+articulo.getString("precio")+" €\n");
                                precio += articulo.getDouble("precio");
                            }
                            bd = new BD();
                            JSONArray menus = bd.obtenerMenusTicket(idTicket);
                            if (menus == null){
                                Utils.showTimeoutAlert(context);
                            }
                            else{
                                for (int i = 0; i < menus.length(); i++){
                                    JSONObject menu = menus.getJSONObject(i);
                                    pedido.setText(pedido.getText()+menu.getString("nombre")+"\n");
                                    pedido.setText(pedido.getText()+"\tPrimero: "+menu.getString("primero")+"\n");
                                    pedido.setText(pedido.getText()+"\tSegundo: "+menu.getString("segundo")+"\n");
                                    pedido.setText(pedido.getText()+"\tPostre: "+menu.getString("postre")+"\n");
                                    pedido.setText(pedido.getText()+"\tBebida: "+menu.getString("bebida")+"\n");
                                    pedido.setText(pedido.getText()+"\t"+menu.getString("precio")+" €\n");
                                    precio += menu.getDouble("precio");
                                }
                            }

                        }

                    }

                }

            }

        }catch(JSONException e) {
            e.printStackTrace();
        }
    }

    private class DownloadImageTask extends AsyncTask<String, Void, Bitmap> {
        ImageView bmImage;

        public DownloadImageTask(ImageView bmImage) {
            this.bmImage = bmImage;
        }

        protected Bitmap doInBackground(String... urls) {
            String urldisplay = urls[0];
            Bitmap mIcon11 = null;
            try {
                InputStream in = new java.net.URL(urldisplay).openStream();
                mIcon11 = BitmapFactory.decodeStream(in);
            } catch (Exception e) {
                Log.e("Error", e.getMessage());
                e.printStackTrace();
            }
            return mIcon11;
        }

        protected void onPostExecute(Bitmap result) {
            bmImage.setImageBitmap(result);
        }
    }
}
