package com.fastservice.app.activities;

import android.content.Context;
import android.content.Intent;
import android.graphics.Color;
import android.graphics.drawable.ColorDrawable;
import android.os.Bundle;
import android.support.v4.app.FragmentActivity;
import android.view.Display;
import android.view.MenuItem;
import android.view.Surface;
import android.view.WindowManager;

import com.fastservice.app.R;
import com.fastservice.app.conections.BD;
import com.fastservice.app.utils.Constants;
import com.fastservice.app.utils.Utils;

import org.json.JSONException;
import org.json.JSONObject;

public class ListaArticulosActivity extends FragmentActivity implements ListaArticulosFragment.ListenerListaArticulos,DetallesArticuloFragment.ListenerButtonDetalle{

    private Context context = this;
    String carta_o_menu;
    String accion;
    String tipo_plato;
    String plato_seleccionado;
    String idMenuAModificar;
    String idMenu;

    @Override
    protected void onCreate(Bundle savedInstanceState) {

        super.onCreate(savedInstanceState);
        setContentView(R.layout.lista_articulos_activity);

        // enable ActionBar app icon to behave as action to toggle nav drawer
        getActionBar().setDisplayHomeAsUpEnabled(true);
        getActionBar().setHomeButtonEnabled(true);
        getActionBar().setBackgroundDrawable(new ColorDrawable(Color.parseColor("#ff800202")));
        setTitle("Carta");

        Bundle extras = getIntent().getExtras();
        carta_o_menu = extras.getString("carta_o_menu", null);
        accion = extras.getString("accion", null);
        tipo_plato = extras.getString("tipo_plato", null);
        idMenu = extras.getString("idMenu", null);
        idMenuAModificar = extras.getString("idMenuAModificar", null);
    }

    @Override
    protected void onResume() {
        super.onResume();

    }

    @Override
    public boolean onOptionsItemSelected(MenuItem item) {
        // Handle action buttons
        switch (item.getItemId()) {
            case android.R.id.home:
                finish();
                return true;
            case R.id.action_settings:
                return true;
            default:
                return super.onOptionsItemSelected(item);
        }
    }

    public void onListItemClick(String id) {
        plato_seleccionado=id;
        //comprobamos la posicion del dipositivo
        WindowManager mWindowManager = (WindowManager) getSystemService(WINDOW_SERVICE);
        Display mDisplay = mWindowManager.getDefaultDisplay();
        //Si esta en posicion apaisado, cargamos el fragment de detalles y lo actualizamos
        if(mDisplay.getRotation() != Surface.ROTATION_0 &&  mDisplay.getRotation() != Surface.ROTATION_180) {
            DetallesArticuloFragment detalles = (DetallesArticuloFragment) getFragmentManager().findFragmentById(R.id.fragment_detalle_articulos);
            detalles.visualizarDetalles(id);
        } else {
            //Si esta en posicion retrato, llamamos a la activity con el detalle de la oferta.
            Intent i = new Intent(getApplicationContext(), DetallesArticuloActivity.class);
            //Log.i("AQUI RECIBO EL ID Y ENVIO EN EL INTENT", id);
            i.putExtra(Constants.Articulo_Seleccionado, id);
            startActivityForResult(i, 0);
        }
    }

    @Override
     protected void onActivityResult(int requestCode, int resultCode, Intent data) {
        super.onActivityResult(requestCode, resultCode, data);
            if (requestCode == 0 && resultCode==RESULT_OK) {
                String aceptado = data.getExtras().getString("aceptado", null);
                if (aceptado != null){
                    seguirPedido();
                }
            }

    }

    @Override
    public void onButtonClick() {
        seguirPedido();
    }

    private void seguirPedido(){
        try {
            BD bd = new BD();
            JSONObject ticketAbierto = bd.obtenerTicketAbiertoDeUsuario(Utils.getLoggedUser(this)).getJSONObject(0);
            if (ticketAbierto == null){
                Utils.showTimeoutAlert(context);
            }
            else{
                String idTicket = ticketAbierto.getString("id_ticket");
                String idRestaurante = ticketAbierto.getString("id_restaurante");
                bd = new BD();
                JSONObject articulo = bd.obtenerArticulosdeRestaurantePorNombre(idRestaurante, plato_seleccionado).getJSONObject(0);
                if (articulo == null){
                    Utils.showTimeoutAlert(context);
                }
                else{
                    String idArticulo = articulo.getString("id_articulo");

                    if (carta_o_menu.equals("carta")) {
                        bd = new BD();
                        bd.añadirArticuloTicket(idTicket, idArticulo);
                        Utils.showToast(this, "Se ha añadido el articulo " + plato_seleccionado + "a su pedido.");
                    } else if (carta_o_menu.equals("menu")) {
                        if (accion.equals("editar")) {
                            bd = new BD();
                            bd.modificarMenuTicket(idMenuAModificar, tipo_plato, idArticulo);
                            finish();
                        } else if (accion.equals("crear")) {
                            Utils.guardarInformacionPlato(this, tipo_plato, idArticulo);
                            Intent intent = new Intent(ListaArticulosActivity.this, ListaArticulosActivity.class);
                            intent.putExtra("accion", accion);
                            intent.putExtra("carta_o_menu", carta_o_menu);
                            intent.putExtra("idMenu", idMenu);
                            if (tipo_plato.equals("Primero")) {
                                intent.putExtra("tipo_plato", "Segundo");
                            } else if (tipo_plato.equals("Segundo")) {
                                intent.putExtra("tipo_plato", "Postre");
                            } else if (tipo_plato.equals("Postre")) {
                                intent.putExtra("tipo_plato", "Bebida");
                            } else if (tipo_plato.equals("Bebida")) {
                                String idPrimero = Utils.obtenerInformacionPlato(this, "Primero");
                                String idSegundo = Utils.obtenerInformacionPlato(this, "Segundo");
                                String idPostre = Utils.obtenerInformacionPlato(this, "Postre");
                                String idBebida = Utils.obtenerInformacionPlato(this, "Bebida");
                                bd = new BD();
                                bd.añadirMenuTicket(idTicket, idMenu, idPrimero, idSegundo, idPostre, idBebida);
                                intent = new Intent(ListaArticulosActivity.this, PedidoActivity.class)
                                        .addFlags(Intent.FLAG_ACTIVITY_CLEAR_TOP | Intent.FLAG_ACTIVITY_SINGLE_TOP);
                                //esto elimina todas las activitys que esten x arriba en la pila que
                                //como volvemos a la de pedido son todas las de seleccion de menu
                            }
                            startActivity(intent);
                        }
                    }
                }
            }
        } catch (JSONException e) {
            e.printStackTrace();
        }
    }
}