package com.fastservice.app.activities;

import android.app.Activity;
import android.content.Context;
import android.os.Bundle;
import android.support.v4.app.ListFragment;
import android.view.LayoutInflater;
import android.view.View;
import android.view.ViewGroup;
import android.widget.ArrayAdapter;
import android.widget.ListView;
import android.widget.TextView;

import com.fastservice.app.R;
import com.fastservice.app.conections.BD;
import com.fastservice.app.utils.Utils;

import org.json.JSONArray;
import org.json.JSONException;
import org.json.JSONObject;

import java.util.ArrayList;


public class ListaHistorialFragment extends ListFragment {

    private Context context = this.getActivity();

    private ListenerListaHistorial mListener;
    private ArrayList<String> fechasTicket,idsTicket,restaurantesTicket;

    private HistorialListAdapter adapter;
    private ListView listViewHistorial;

    public ListaHistorialFragment() {
        // Required empty public constructor
    }

    @Override
    public void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        fechasTicket = new ArrayList<String>();
        idsTicket = new ArrayList<String>();
        restaurantesTicket = new ArrayList<String>();
        obtenerHistoricoDeLaBD();
    }

    @Override
    public void onResume() {
        super.onResume();

        listViewHistorial = getListView();

        adapter = new HistorialListAdapter(getActivity(),0);
        listViewHistorial.setAdapter(adapter);
    }

    private void obtenerHistoricoDeLaBD(){
        BD bd = new BD();
        JSONArray tickets = bd.obtenerHistoricoDelUsuario(Utils.getLoggedUser(getActivity()));
        if (tickets == null){
            Utils.showTimeoutAlert(context);
        }
        else{
            for (int i =0; i<tickets.length(); i++){
                JSONObject ticket = null;
                try {
                    ticket = tickets.getJSONObject(i);
                    idsTicket.add(ticket.getString("id_ticket"));
                    fechasTicket.add(ticket.getString("fecha"));
                    restaurantesTicket.add(ticket.getString("nombreRestaurante"));
                } catch (JSONException e) {
                    e.printStackTrace();
                }
            }
        }
    }

    @Override
    public View onCreateView(LayoutInflater inflater, ViewGroup container,
                             Bundle savedInstanceState) {
        // Inflate the layout for this fragment
        super.onCreateView(inflater,container,savedInstanceState);
        return inflater.inflate(R.layout.fragment_lista_historial, container, false);
    }


    @Override
    public void onListItemClick(ListView l, View v, int position, long id) {
        super.onListItemClick(l, v, position, id);
        mListener.onListItemClick(position);
    }

    @Override
    public void onAttach(Activity activity) {
        super.onAttach(activity);
        try {
            mListener = (ListenerListaHistorial) activity;
        } catch (ClassCastException e) {
            throw new ClassCastException(activity.toString()
                    + " must implement OnFragmentInteractionListener");
        }
    }

    @Override
    public void onDetach() {
        super.onDetach();
        mListener = null;
    }


    public interface ListenerListaHistorial {
        public void onListItemClick(int posicion);
    }

    public class HistorialListAdapter extends ArrayAdapter {
        private Context context;

        public HistorialListAdapter(Context context, int resource) {
            super(context, resource);
            this.context = context;
        }

        @Override
        public View getView(int position, View convertView, ViewGroup parent) {
            LayoutInflater inflater = LayoutInflater.from(context);
            View item = inflater.inflate(R.layout.lista_historial_item, null);
            TextView id,restaurante,fecha;
            id = (TextView) item.findViewById(R.id.id);
            restaurante = (TextView) item.findViewById(R.id.restaurante);
            fecha = (TextView) item.findViewById(R.id.fecha);

            id.setText(idsTicket.get(position));
            restaurante.setText(restaurantesTicket.get(position));
            String f = fechasTicket.get(position).substring(0,19);
            fecha.setText(f.split("T")[0] + " " + f.split("T")[1]);

            return item;
        }

        @Override
        public int getCount() {
            return idsTicket.size();
        }
    }
}
