package com.fastservice.app.activities;

import android.app.Activity;
import android.content.Context;
import android.content.Intent;
import android.graphics.Color;
import android.graphics.drawable.ColorDrawable;
import android.os.Bundle;
import android.support.v4.app.ActionBarDrawerToggle;
import android.support.v4.widget.DrawerLayout;
import android.view.LayoutInflater;
import android.view.Menu;
import android.view.MenuInflater;
import android.view.MenuItem;
import android.view.View;
import android.view.ViewGroup;
import android.widget.ArrayAdapter;
import android.widget.Button;
import android.widget.ListView;
import android.widget.TextView;

import com.fastservice.app.R;
import com.fastservice.app.conections.BD;
import com.fastservice.app.utils.Utils;

import org.json.JSONArray;
import org.json.JSONException;
import org.json.JSONObject;

public class ListaMenuActivity extends Activity {

    private JSONArray menus = new JSONArray();
    private BD bd;

    private DrawerLayout mDrawerLayout;
    private ListView mDrawerList;
    private ActionBarDrawerToggle mDrawerToggle;

    private CharSequence mDrawerTitle;
    private CharSequence mTitle;
    private String[] mPlanetTitles = "Pedido Actual,Historico,Logout".split(",");

    private ListView listViewPedido;
    private PedidosListAdapter adapter;

    private Context context = this;

    private void obtenerMenusDeLaBD(){
        bd = new BD();
        JSONObject ticketAbierto = null;
        try {
            ticketAbierto = bd.obtenerTicketAbiertoDeUsuario(Utils.getLoggedUser(this)).getJSONObject(0);
            if (ticketAbierto == null){
                Utils.showTimeoutAlert(context);
            }
            else{
                bd = new BD();
                menus = bd.obtenerMenusRestaurante(ticketAbierto.getString("id_restaurante"));
                if (menus == null){
                    Utils.showTimeoutAlert(context);
                }
            }

        } catch (JSONException e) {
            e.printStackTrace();
        }

    }
    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.lista_menu_activity);

        listViewPedido = (ListView) findViewById(R.id.listView);

        // enable ActionBar app icon to behave as action to toggle nav drawer
        getActionBar().setDisplayHomeAsUpEnabled(true);
        getActionBar().setHomeButtonEnabled(true);
        getActionBar().setBackgroundDrawable(new ColorDrawable(Color.parseColor("#ff800202")));


    }

    @Override
    protected void onResume() {
        obtenerMenusDeLaBD();
        super.onResume();
        setTitle("Seleccione un menú");
        adapter = new PedidosListAdapter(this,0);
        listViewPedido.setAdapter(adapter);
    }

    @Override
    public boolean onCreateOptionsMenu(Menu menu) {
        MenuInflater inflater = getMenuInflater();
        inflater.inflate(R.menu.lista__menu_, menu);
        return super.onCreateOptionsMenu(menu);
    }

    @Override
    public boolean onOptionsItemSelected(MenuItem item) {
        // Handle action buttons
        switch (item.getItemId()) {
            case android.R.id.home:
                finish();
                return true;
            case R.id.action_settings:
                return true;
            default:
                return super.onOptionsItemSelected(item);
        }
    }

    public class PedidosListAdapter extends ArrayAdapter {
        private Context context;

        public PedidosListAdapter(Context context, int resource) {
            super(context, resource);
            this.context = context;
        }

        @Override
        public View getView(int position, View convertView, ViewGroup parent) {
            LayoutInflater inflater = LayoutInflater.from(context);
            View item = inflater.inflate(R.layout.lista_menu_item, null);
            try {
                final JSONObject menu = menus.getJSONObject(position);
                TextView nombre,precio,descripcion;
                nombre = (TextView) item.findViewById(R.id.nombre);
                precio = (TextView) item.findViewById(R.id.precio);
                descripcion = (TextView) item.findViewById(R.id.descripcion);

                nombre.setText(menu.getString("nombre"));
                precio.setText(menu.getString("precio")+ " €");
                descripcion.setText(menu.getString("descripcion"));

                Button seleccionar = (Button) item.findViewById(R.id.seleccionar);
                seleccionar.setOnClickListener(new View.OnClickListener() {
                    @Override
                    public void onClick(View view) {
                        try {
                            String idMenu = menu.getString("id_menu");
                            Intent intent = new Intent(ListaMenuActivity.this,ListaArticulosActivity.class);
                            intent.putExtra("carta_o_menu","menu");
                            intent.putExtra("accion","crear");
                            intent.putExtra("idMenu",idMenu);
                            intent.putExtra("tipo_plato","Primero");
                            startActivity(intent);
                        } catch (JSONException e) {
                            e.printStackTrace();
                        }
                    }
                });
            } catch (JSONException e) {
                e.printStackTrace();
            } {

            }

            return item;
        }

        @Override
        public int getCount() {
            return menus.length();
        }
    }
}
