package com.fastservice.app.activities;

import android.app.Activity;
import android.app.AlertDialog;
import android.content.Context;
import android.content.DialogInterface;
import android.content.Intent;
import android.content.res.Configuration;
import android.graphics.Color;
import android.graphics.drawable.ColorDrawable;
import android.net.wifi.p2p.WifiP2pManager;
import android.os.Bundle;
import android.support.v4.app.ActionBarDrawerToggle;
import android.support.v4.view.GravityCompat;
import android.support.v4.widget.DrawerLayout;
import android.view.LayoutInflater;
import android.view.Menu;
import android.view.MenuInflater;
import android.view.MenuItem;
import android.view.View;
import android.view.ViewGroup;
import android.widget.AdapterView;
import android.widget.ArrayAdapter;
import android.widget.ImageButton;
import android.widget.ListView;
import android.widget.TextView;

import com.fastservice.app.R;
import com.fastservice.app.conections.BD;
import com.fastservice.app.utils.Utils;

import org.json.JSONArray;
import org.json.JSONException;
import org.json.JSONObject;

public class PedidoActivity extends Activity {

    private JSONArray menusPedido = new JSONArray();
    private JSONArray articulosCartaPedido = new JSONArray();
    private double precio_total = 0.0;
    private int pedidosPendientesEnvio,pedidosPendientesConfirmacion,pedidosAtendidos = 0;
    private String idTicketActual;
    private BD bd;

    private DrawerLayout mDrawerLayout;
    private ListView mDrawerList;
    private ActionBarDrawerToggle mDrawerToggle;

    private CharSequence mDrawerTitle;
    private CharSequence mTitle;
    private String[] mPlanetTitles = "Ver historial,Eliminar Ticket,Ver Ayuda,Logout".split(",");

    private ListView listViewPedido;
    private PedidosListAdapter adapter;

    private ImageButton anadir;

    private Context context = this;

    private void obtenerArticulosDeLaBD(){
        bd = new BD();
        JSONObject ticketAbierto = null;
        try {
            ticketAbierto = bd.obtenerTicketAbiertoDeUsuario(Utils.getLoggedUser(this)).getJSONObject(0);
                if (ticketAbierto.length()!=0){
                    if(ticketAbierto.getString("pago").equals("solicitado")){
                        ImageButton anadir = (ImageButton) findViewById(R.id.anadir);
                        anadir.setVisibility(View.GONE);
                    }
                    idTicketActual = ticketAbierto.getString("id_ticket");
                    bd = new BD();
                    menusPedido = bd.obtenerMenusTicket(ticketAbierto.getString("id_ticket"));
                    if (menusPedido == null){
                        Utils.showTimeoutAlert(context);
                    }
                    else{
                        bd = new BD();
                        articulosCartaPedido = bd.obtenerArticulosCartaTicket(ticketAbierto.getString("id_ticket"));
                        if (articulosCartaPedido == null){
                            Utils.showTimeoutAlert(context);
                        }
                        else{
                            obtenerPrecioPedido();
                            obtenerEstadoPedido();
                        }
                    }

                }
                else {
                    Intent intent = new Intent(PedidoActivity.this,InstruccionesActivity.class);
                    finish();
                    startActivity(intent);
                }
        } catch (JSONException e) {
            //no hay ticket luego cierro la activity
                Intent intent = new Intent(PedidoActivity.this,InstruccionesActivity.class);
                finish();
                startActivity(intent);
        }

    }

    private void obtenerPrecioPedido()
    {
        precio_total=0;
        for (int i = 0; i<menusPedido.length(); i++){
            try {
                JSONObject menu = menusPedido.getJSONObject(i);
                precio_total+=menu.getDouble("precio");
            } catch (JSONException e) {
                e.printStackTrace();
            }
        }
        for (int i = 0; i<articulosCartaPedido.length(); i++){
            try {
                JSONObject articulo = articulosCartaPedido.getJSONObject(i);
                precio_total+=articulo.getDouble("precio");
            } catch (JSONException e) {
                e.printStackTrace();
            }
        }
    }

    private void obtenerEstadoPedido(){
        pedidosPendientesEnvio = 0;
        pedidosPendientesConfirmacion = 0;
        pedidosAtendidos = 0;
        for (int i = 0; i<menusPedido.length(); i++){
            try {
                JSONObject menu = menusPedido.getJSONObject(i);
                String estado = menu.getString("estado");
                if (estado.equals("pendiente de envio")){
                    pedidosPendientesEnvio+=1;
                }
                else  if (estado.equals("pendiente de confirmacion")){
                    pedidosPendientesConfirmacion+=1;
                }
                else  if (estado.equals("atendido")) {
                    pedidosAtendidos+=1;
                }
            } catch (JSONException e) {
                e.printStackTrace();
            }
        }
        for (int i = 0; i<articulosCartaPedido.length(); i++){
            try {
                JSONObject articulo = articulosCartaPedido.getJSONObject(i);
                String estado = articulo.getString("estado");
                if (estado.equals("pendiente de envio")){
                    pedidosPendientesEnvio+=1;
                }
                else  if (estado.equals("pendiente de confirmacion")){
                    pedidosPendientesConfirmacion+=1;
                }
                else  if (estado.equals("atendido")) {
                    pedidosAtendidos+=1;
                }
            } catch (JSONException e) {
                e.printStackTrace();
            }
        }
    }
    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.pedido_activity);

        listViewPedido = (ListView) findViewById(R.id.listView);

        mTitle = mDrawerTitle = getTitle();
        //mPlanetTitles = getResources().getStringArray(R.array.planets_array);
        mDrawerLayout = (DrawerLayout) findViewById(R.id.drawer_layout);
        mDrawerList = (ListView) findViewById(R.id.left_drawer);

        // set a custom shadow that overlays the main content when the drawer opens
        mDrawerLayout.setDrawerShadow(R.drawable.drawer_shadow, GravityCompat.START);
        // set up the drawer's list view with items and click listener
        mDrawerList.setAdapter(new ArrayAdapter<String>(this,
                R.layout.drawer_list_item, mPlanetTitles));
        mDrawerList.setOnItemClickListener(new DrawerItemClickListener());

        // enable ActionBar app icon to behave as action to toggle nav drawer
        getActionBar().setDisplayHomeAsUpEnabled(true);
        getActionBar().setHomeButtonEnabled(true);
        getActionBar().setBackgroundDrawable(new ColorDrawable(Color.parseColor("#ff800202")));


        // ActionBarDrawerToggle ties together the the proper interactions
        // between the sliding drawer and the action bar app icon
        mDrawerToggle = new ActionBarDrawerToggle(
                this,                  /* host Activity */
                mDrawerLayout,         /* DrawerLayout object */
                R.drawable.ic_drawer,  /* nav drawer image to replace 'Up' caret */
                R.string.drawer_open,  /* "open drawer" description for accessibility */
                R.string.drawer_close  /* "close drawer" description for accessibility */
        ) {
            public void onDrawerClosed(View view) {
                //getActionBar().setTitle(mTitle);
                invalidateOptionsMenu(); // creates call to onPrepareOptionsMenu()
            }

            public void onDrawerOpened(View drawerView) {
                //getActionBar().setTitle(mDrawerTitle);
                invalidateOptionsMenu(); // creates call to onPrepareOptionsMenu()
            }
        };
        mDrawerLayout.setDrawerListener(mDrawerToggle);

        if (savedInstanceState == null) {
            selectItem(0);
        }
    }

    @Override
    protected void onResume() {
        obtenerArticulosDeLaBD();
        super.onResume();
        setTitle("Pedido");
        adapter = new PedidosListAdapter(this,0);
        listViewPedido.setAdapter(adapter);
        invalidateOptionsMenu();
        anadir = (ImageButton) findViewById(R.id.anadir);
        anadir.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View view) {
                AlertDialog.Builder builder = new AlertDialog.Builder(context);
                builder.setMessage("Seleccione el tipo de articulo que desea añadir.")
                        .setPositiveButton("Menu", new DialogInterface.OnClickListener() {
                            @Override
                            public void onClick(DialogInterface dialogInterface, int i) {
                                Intent intent = new Intent(PedidoActivity.this, ListaMenuActivity.class);
                                startActivity(intent);
                            }
                        })
                        .setNegativeButton("Articulo de la carta", new DialogInterface.OnClickListener() {
                            @Override
                            public void onClick(DialogInterface dialogInterface, int i) {
                                Intent intent = new Intent(PedidoActivity.this, ListaArticulosActivity.class);
                                intent.putExtra("carta_o_menu", "carta");
                                startActivity(intent);
                            }
                        });
                AlertDialog aviso = builder.create();
                aviso.show();
            }
        });
    }

    @Override
    public boolean onCreateOptionsMenu(Menu menu) {
        MenuInflater inflater = getMenuInflater();
        inflater.inflate(R.menu.pedido, menu);
        return super.onCreateOptionsMenu(menu);
    }

    @Override
    public boolean onPrepareOptionsMenu(Menu menu) {
        super.onPrepareOptionsMenu(menu);
        menu.findItem(R.id.action_enviar).setVisible(false);
        menu.findItem(R.id.action_pagar).setVisible(false);
        if (pedidosPendientesEnvio>0){
            menu.findItem(R.id.action_enviar).setVisible(true);
        }
        else if ((pedidosAtendidos==menusPedido.length()+articulosCartaPedido.length())&&(pedidosAtendidos>0)){
            menu.findItem(R.id.action_pagar).setVisible(true);
        }
        return true;
    }

    @Override
    public boolean onOptionsItemSelected(MenuItem item) {
        // The action bar home/up action should open or close the drawer.
        // ActionBarDrawerToggle will take care of this.
        if (mDrawerToggle.onOptionsItemSelected(item)) {
            return true;
        }
        // Handle action buttons
        switch (item.getItemId()) {
            case R.id.action_reload:
                obtenerArticulosDeLaBD();
                adapter.notifyDataSetChanged();
                invalidateOptionsMenu();
                return true;
            case R.id.action_pagar:
                //Para que se pueda dar click a este boton se cumplen las condiciones de pago
                bd = new BD();
                bd.solicitarPagoTicket(idTicketActual);
                Utils.showToast(context,"El Ticket se encuentra Pendiente de Pago, en unos minutos aparecera el camarero para proceder con el pago");
                return true;
            case R.id.action_enviar:
                //Para que se pueda dar click a este boton se cumplen las condiciones de envio al camarero
                bd= new BD();
                bd.pedirArticulosPendientes(idTicketActual);
                obtenerArticulosDeLaBD();
                adapter.notifyDataSetChanged();
                invalidateOptionsMenu();
                return true;
            default:
                return super.onOptionsItemSelected(item);
        }
    }

    /* The click listner for ListView in the navigation drawer */
    private class DrawerItemClickListener implements ListView.OnItemClickListener {
        @Override
        public void onItemClick(AdapterView<?> parent, View view, int position, long id) {
            selectItem(position);
            switch (position){
                case 0://Ver Historico
                    bd = new BD();
                    JSONArray historico = bd.obtenerHistoricoDelUsuario(Utils.getLoggedUser(context));
                    if (historico == null){
                        Utils.showTimeoutAlert(context);
                    }
                    else{
                        if (historico.length()>0){
                            Intent intent = new Intent(PedidoActivity.this,ListaHistorialActivity.class);
                            startActivity(intent);
                        }
                        else{
                            Utils.showToast(context,"Lo sentimos, aun no dispones de ningun pedido en tu historial.");
                        }
                    }
                    break;
                case 1://Eliminar Ticket
                    if (menusPedido.length()==0 && articulosCartaPedido.length()==0){
                        bd = new BD();
                        bd.eliminarTicket(idTicketActual);
                        Intent intent = new Intent(PedidoActivity.this, PedidoActivity.class)
                                .addFlags(Intent.FLAG_ACTIVITY_CLEAR_TOP | Intent.FLAG_ACTIVITY_SINGLE_TOP);
                        startActivity(intent);
                        finish();
                    }
                    else{
                        Utils.showToast(context,"El ticket no puede ser eliminado dado que contiene articulos en el.");
                    }
                    break;
                case 2://Ver Ayuda
                    Intent i = new Intent (PedidoActivity.this, AyudaActivity.class);
                    startActivity(i);
                    break;
                case 3://Logout
                    Utils.logout(getApplicationContext());
                    Intent intent = new Intent(PedidoActivity.this, LoginActivity.class);
                    intent.setFlags(Intent.FLAG_ACTIVITY_CLEAR_TOP);
                    startActivity(intent);
                    finish();
                    break;
                default:
                    break;
            }

        }
    }

    private void selectItem(int position) {
        // update the main content by replacing fragments
        android.app.Fragment fragment = new PlanetFragment();
        Bundle args = new Bundle();
        args.putInt(PlanetFragment.ARG_PLANET_NUMBER, position);
        fragment.setArguments(args);

        android.app.FragmentManager fragmentManager = getFragmentManager();
        fragmentManager.beginTransaction().replace(R.id.content_frame, fragment).commit();

        // update selected item and title, then close the drawer
        mDrawerList.setItemChecked(position, true);
        setTitle(mPlanetTitles[position]);
        mDrawerLayout.closeDrawer(mDrawerList);
    }


    @Override
    public void setTitle(CharSequence title) {
        mTitle = title;
        getActionBar().setTitle(mTitle);
    }

    /**
     * When using the ActionBarDrawerToggle, you must call it during
     * onPostCreate() and onConfigurationChanged()...
     */

    @Override
    protected void onPostCreate(Bundle savedInstanceState) {
        super.onPostCreate(savedInstanceState);
        // Sync the toggle state after onRestoreInstanceState has occurred.
        mDrawerToggle.syncState();
    }

    @Override
    public void onConfigurationChanged(Configuration newConfig) {
        super.onConfigurationChanged(newConfig);
        // Pass any configuration change to the drawer toggls
        mDrawerToggle.onConfigurationChanged(newConfig);
    }

    /**
     * Fragment that appears in the "content_frame", shows a planet
     */
    public static class PlanetFragment extends android.app.Fragment {
        public static final String ARG_PLANET_NUMBER = "planet_number";

        public PlanetFragment() {
            // Empty constructor required for fragment subclasses
        }
    }

    public class PedidosListAdapter extends ArrayAdapter {
        private Context context;

        public PedidosListAdapter(Context context, int resource) {
            super(context, resource);
            this.context = context;
        }

        @Override
        public View getView(int position, View convertView, ViewGroup parent) {
            LayoutInflater inflater = LayoutInflater.from(context);
            View item;
            if (position==0){
                invalidateOptionsMenu();
            }
            if (position==0&&menusPedido.length()==0&&articulosCartaPedido.length()==0){
                item = inflater.inflate(R.layout.pedido_vacio_item, null);
            }
            else{
                if (position<menusPedido.length()){
                    TextView primero,segundo,postre,bebida,nombre,precio,id;
                    item = inflater.inflate(R.layout.pedido_menu_item, null);
                    try {
                        final JSONObject menu = menusPedido.getJSONObject(position);
                        primero = (TextView) item.findViewById(R.id.primero);
                        primero.setText(primero.getText()+menu.getString("primero"));
                        segundo = (TextView) item.findViewById(R.id.segundo);
                        segundo.setText(segundo.getText() + menu.getString("segundo"));
                        postre= (TextView) item.findViewById(R.id.postre);
                        postre.setText(postre.getText()+menu.getString("postre"));
                        bebida= (TextView) item.findViewById(R.id.bebida);
                        bebida.setText(bebida.getText()+menu.getString("bebida"));
                        nombre = (TextView) item.findViewById(R.id.nombre);
                        nombre.setText(menu.getString("nombre"));
                        precio = (TextView) item.findViewById(R.id.precio);
                        precio.setText(menu.getString("precio")+" €");
                        id = (TextView) item.findViewById(R.id.id);
                        id.setText(menu.getString("id_ticket_menu"));


                        ImageButton botonModificar = (ImageButton) item.findViewById(R.id.modificar);
                        ImageButton botonEliminar = (ImageButton) item.findViewById(R.id.eliminar);
                        TextView textoEstado = (TextView) item.findViewById(R.id.estado);
                        if (menu.getString("estado").equals("pendiente de envio")){
                            botonEliminar.setOnClickListener(new View.OnClickListener() {
                                @Override
                                public void onClick(View view) {
                                    AlertDialog.Builder builder = new AlertDialog.Builder(context);
                                    try {
                                        builder.setMessage("¿Esta seguro que desea eliminar el Menu: "+menu.getString("nombre")+ "?")
                                                .setPositiveButton("Si",new DialogInterface.OnClickListener() {
                                                    @Override
                                                    public void onClick(DialogInterface dialogInterface, int i) {
                                                        bd = new BD();
                                                        try {
                                                            bd.eliminarMenuTicket(menu.getString("id_ticket_menu"));
                                                            obtenerArticulosDeLaBD();
                                                            adapter.notifyDataSetChanged();
                                                            invalidateOptionsMenu();
                                                        } catch (JSONException e) {
                                                            e.printStackTrace();
                                                        }
                                                    }
                                                })
                                                .setNegativeButton("No",new DialogInterface.OnClickListener() {
                                                    @Override
                                                    public void onClick(DialogInterface dialogInterface, int i) {
                                                        //no hace nada
                                                    }
                                                });
                                    } catch (JSONException e) {
                                        e.printStackTrace();
                                    }
                                    AlertDialog aviso = builder.create();
                                    aviso.show();
                                }
                            });
                            botonModificar.setOnClickListener(new View.OnClickListener() {
                                @Override
                                public void onClick(View view) {
                                    AlertDialog.Builder builder = new AlertDialog.Builder(context);
                                    try {
                                        String[] platos = {menu.getString("primero"),menu.getString("segundo"),menu.getString("postre"),menu.getString("bebida")};
                                        builder.setTitle("Seleccione el articulo que desea editar en el menú");
                                        builder.setItems(platos,new DialogInterface.OnClickListener() {
                                            @Override
                                            public void onClick(DialogInterface dialogInterface, int i) {
                                                Intent intent = new Intent(PedidoActivity.this,ListaArticulosActivity.class);

                                                try {
                                                    String idMenu = menu.getString("id_menu");
                                                    String idMenuAModificar = menu.getString("id_ticket_menu");
                                                    intent.putExtra("carta_o_menu","menu");
                                                    intent.putExtra("accion","editar");
                                                    intent.putExtra("idMenu",idMenu);
                                                    intent.putExtra("idMenuAModificar",idMenuAModificar);

                                                    switch (i){
                                                        case 0:
                                                            intent.putExtra("tipo_plato","Primero");
                                                            break;
                                                        case 1:
                                                            intent.putExtra("tipo_plato","Segundo");
                                                            break;
                                                        case 2:
                                                            intent.putExtra("tipo_plato","Postre");
                                                            break;
                                                        case 3:
                                                            intent.putExtra("tipo_plato","Bebida");
                                                            break;
                                                        default:
                                                            break;
                                                    }
                                                    startActivity(intent);
                                                } catch (JSONException e) {
                                                    e.printStackTrace();
                                                }
                                            }
                                        });
                                    } catch (JSONException e) {
                                        e.printStackTrace();
                                    }
                                    AlertDialog aviso = builder.create();
                                    aviso.show();
                                }
                            });

                        }
                        else{
                            botonModificar.setVisibility(View.GONE);
                            botonEliminar.setVisibility(View.GONE);
                            textoEstado.setVisibility(View.VISIBLE);

                            if (menu.getString("estado").equals("pendiente de confirmacion")){
                                textoEstado.setText("PENDIENTE");
                                textoEstado.setTextColor(Color.parseColor("#FE9A2E"));
                            }
                            else if (menu.getString("estado").equals("atendido")){
                                textoEstado.setText("ATENDIDO");
                                textoEstado.setTextColor(Color.parseColor("#2EFE2E"));
                            }
                        }

                    } catch (JSONException e) {
                        e.printStackTrace();
                    }

                }
                else if(position<menusPedido.length()+articulosCartaPedido.length()){
                    TextView nombre,precio,id;
                    item = inflater.inflate(R.layout.pedido_carta_item, null);
                    try {
                        final JSONObject articulo = articulosCartaPedido.getJSONObject(position - menusPedido.length());
                        nombre = (TextView) item.findViewById(R.id.nombre);
                        nombre.setText(articulo.getString("nombre"));
                        precio = (TextView) item.findViewById(R.id.precio);
                        precio.setText(articulo.getString("precio")+" €");
                        id = (TextView) item.findViewById(R.id.id);
                        id.setText(articulo.getString("id_ticket_articulo"));

                        ImageButton botonEliminar = (ImageButton) item.findViewById(R.id.eliminar);
                        TextView textoEstado = (TextView) item.findViewById(R.id.estado);
                        if (articulo.getString("estado").equals("pendiente de envio")){
                            botonEliminar.setOnClickListener(new View.OnClickListener() {
                                @Override
                                public void onClick(View view) {
                                    AlertDialog.Builder builder = new AlertDialog.Builder(context);
                                    try {
                                        builder.setMessage("¿Esta seguro que desea eliminar el articulo: "+articulo.getString("nombre")+ "?")
                                                .setPositiveButton("Si",new DialogInterface.OnClickListener() {
                                                    @Override
                                                    public void onClick(DialogInterface dialogInterface, int i) {
                                                        bd = new BD();
                                                        try {
                                                            bd.eliminarArticuloTicket(articulo.getString("id_ticket_articulo"));
                                                            obtenerArticulosDeLaBD();
                                                            adapter.notifyDataSetChanged();
                                                            invalidateOptionsMenu();
                                                        } catch (JSONException e) {
                                                            e.printStackTrace();
                                                        }
                                                    }
                                                })
                                                .setNegativeButton("No",new DialogInterface.OnClickListener() {
                                                    @Override
                                                    public void onClick(DialogInterface dialogInterface, int i) {
                                                        //no hace nada
                                                    }
                                                });
                                    } catch (JSONException e) {
                                        e.printStackTrace();
                                    }
                                    AlertDialog aviso = builder.create();
                                    aviso.show();
                                }
                            });
                        }
                        else{
                            botonEliminar.setVisibility(View.GONE);
                            textoEstado.setVisibility(View.VISIBLE);

                            if (articulo.getString("estado").equals("pendiente de confirmacion")){
                                textoEstado.setText("PENDIENTE");
                                textoEstado.setTextColor(Color.parseColor("#FE9A2E"));
                            }
                            else if (articulo.getString("estado").equals("atendido")){
                                textoEstado.setText("ATENDIDO");
                                textoEstado.setTextColor(Color.parseColor("#2EFE2E"));
                            }
                        }
                    } catch (JSONException e) {
                        e.printStackTrace();
                    }
                }
                else{
                    item = inflater.inflate(R.layout.pedido_total_item, null);
                    TextView total = (TextView) item.findViewById(R.id.Total);
                    total.setText("Total del Pedido: "+precio_total+" €");
                }
            }
            return item;
        }

        @Override
        public int getCount() {
            //return super.getCount();
            int elementos = menusPedido.length()+articulosCartaPedido.length();
            if (elementos>0){
                return elementos+1;
            }
            else{
                return 2;
            }
        }
    }

}