package com.fastservice.app.activities;

import android.app.ActionBar;
import android.app.Activity;
import android.content.Context;
import android.os.Bundle;
import android.view.View;
import android.widget.Button;
import android.widget.EditText;

import com.fastservice.app.R;
import com.fastservice.app.conections.BD;
import com.fastservice.app.utils.Utils;

import org.json.JSONArray;

public class RegistroActivity extends Activity {

    private Button createUser;
    private EditText et_user,et_pass,et_name,et_surname,et_confirmPass,et_email;
    private String user,pass,name,surname,confirmPass,email;
    private BD bd = new BD();
    private Context context = this;
    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.register_activity);
    }

    @Override
    protected void onResume() {
        super.onResume();
        ActionBar actionBar = getActionBar();
        actionBar.hide();
        getElemtsFromLayout();
        setListeners();
    }

    private void getElemtsFromLayout(){
        et_user = (EditText) findViewById(R.id.editTextUser);
        et_pass = (EditText) findViewById(R.id.editTextPass);
        et_confirmPass = (EditText) findViewById(R.id.editTextConfirmPass);
        et_email = (EditText) findViewById(R.id.editTextEmail);
        et_name = (EditText) findViewById(R.id.editTextName);
        et_surname = (EditText) findViewById(R.id.editTextSurname);
        createUser = (Button) findViewById(R.id.buttonCreateUser);
    }

    private void setListeners(){
        createUser.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View view) {
                user = et_user.getText().toString().trim();
                pass = et_pass.getText().toString().trim();
                confirmPass = et_confirmPass.getText().toString().trim();
                email = et_email.getText().toString().trim();
                name = et_name.getText().toString().trim();
                surname = et_surname.getText().toString().trim();
                if (pass.equals(confirmPass)){
                    if (!user.isEmpty() && !pass.isEmpty() && !confirmPass.isEmpty() &&
                            !email.isEmpty() && !name.isEmpty() && !surname.isEmpty()){
                        bd = new BD();
                        JSONArray resultado = bd.obtenerUsuario(user);
                        if (resultado == null){
                            Utils.showTimeoutAlert(context);
                        }
                        else{
                            if (resultado.length() == 1){
                                Utils.showToast(getApplicationContext(), "Ya existe en el sistema un usuario" +
                                        " con el Nombre de Usuario introducido");
                            }
                            else if(resultado.length() == 0){
                                bd = new BD();
                                bd.crearUsuario(user,name,surname,Utils.getPasswordHash(pass),email,"No_GCM_Key");
                                userCreated();
                            }
                        }

                    }
                    else{
                        Utils.showToast(getApplicationContext(),"No puede haber campos vacios");
                    }
                }
                else{
                    Utils.showToast(getApplicationContext(),"Las Contraseñas no coinciden");
                }
            }
        });
    }


    private void userCreated(){
        Utils.showToast(getApplicationContext(),"Se ha creado correctamente el usuario "+user);
        finish();
    }
}
