package com.fastservice.app.conections;

import android.provider.SyncStateContract;

import com.fastservice.app.utils.Constants;

import org.json.JSONArray;
import org.json.JSONException;
import org.json.JSONObject;

import java.net.ContentHandler;
import java.util.concurrent.ExecutionException;

/**
 * Created by JonAnder.
 */
public class BD {
    ConexionBD bd = new ConexionBD();

    public JSONArray obtenerUsuario(String nombreUsuario){
        JSONArray resultado = new JSONArray();
        bd.execute( Constants.Listar,
                    Constants.Tabla_Usuarios,
                    Constants.Tabla_Usuarios_ID+"='"+nombreUsuario+"'");

        try {
            resultado = bd.get();
        }
        catch (InterruptedException e) {
            e.printStackTrace();
        }
        catch (ExecutionException e) {
            e.printStackTrace();
        }
        return resultado;
    }


    public JSONArray crearUsuario(String nombre_usuario,
                              String nombre,
                              String apellido,
                              String password_hash,
                              String email,
                              String gcm_key){
        JSONArray resultado = new JSONArray();
        bd.execute( Constants.Insertar,
                    Constants.Tabla_Usuarios,
                    Constants.Tabla_Usuarios_ID+"="+nombre_usuario,
                    Constants.Tabla_Usuarios_nombre+"="+nombre,
                    Constants.Tabla_Usuarios_apellido+"="+apellido,
                    Constants.Tabla_Usuarios_password+"="+password_hash,
                    Constants.Tabla_Usuarios_email+"="+email,
                    Constants.Tabla_Usuarios_gcm+"="+gcm_key,
                    Constants.Tabla_Usuarios_tipo+"="+"Usuario");
        try {
            resultado = bd.get();
        }
        catch (InterruptedException e) {
            e.printStackTrace();
        }
        catch (ExecutionException e) {
            e.printStackTrace();
        }
        return resultado;
    }


    public void actualizarGcmUsuario(String usuario,String gcm_key){
        bd.execute( Constants.Actualizar,
                    Constants.Tabla_Usuarios,
                    Constants.Tabla_Usuarios_ID+"="+usuario,
                    Constants.Tabla_Usuarios_gcm+"="+gcm_key);
        try {
            bd.get();
        } catch (InterruptedException e) {
            e.printStackTrace();
        } catch (ExecutionException e) {
            e.printStackTrace();
        }
    }


    public void crearTicket(String usuario, String restaurante, String mesa){
        bd.execute( Constants.Insertar,
                    Constants.Tabla_Tickets,
                    Constants.Tabla_Tickets_usuario+"="+usuario,
                    Constants.Tabla_Tickets_restaurante+"="+restaurante,
                    Constants.Tabla_Tickets_mesa+"="+mesa,
                    Constants.Tabla_Tickets_abierto+"=True",
                    Constants.Tabla_Tickets_precio+"=0.0",
                    Constants.Tabla_Tickets_pago+"=pendiente");
        try {
            bd.get();
        } catch (InterruptedException e) {
            e.printStackTrace();
        } catch (ExecutionException e) {
            e.printStackTrace();
        }
    }


    public JSONArray obtenerTicketAbiertoDeUsuario(String nombreUsuario){
        JSONArray resultado = new JSONArray();
        bd.execute( Constants.Listar,
                    Constants.Tabla_Tickets,
                    Constants.Tabla_Tickets_usuario+"='"+nombreUsuario+"'"
                            +"&"+
                    Constants.Tabla_Tickets_abierto+"='True'");

        try {
            resultado = bd.get();
        }
        catch (InterruptedException e) {
            e.printStackTrace();
        }
        catch (ExecutionException e) {
            e.printStackTrace();
        }
        return resultado;
    }

    public JSONArray obtenerTicket(String idTicket){
        JSONArray resultado = new JSONArray();
        bd.execute( Constants.Listar,
                Constants.Tabla_Tickets,
                Constants.Tabla_Tickets_ID+"='"+idTicket+"'");

        try {
            resultado = bd.get();
        }
        catch (InterruptedException e) {
            e.printStackTrace();
        }
        catch (ExecutionException e) {
            e.printStackTrace();
        }
        return resultado;
    }

    public JSONArray obtenerRestaurante(String idRestaurante){
        JSONArray resultado = new JSONArray();
        bd.execute( Constants.Listar,
                Constants.Tabla_Restaurantes,
                Constants.Tabla_Restaurantes_ID+"='"+idRestaurante+"'");

        try {
            resultado = bd.get();
        }
        catch (InterruptedException e) {
            e.printStackTrace();
        }
        catch (ExecutionException e) {
            e.printStackTrace();
        }
        return resultado;
    }

    public JSONArray obtenerMenusTicket(String idTicket){
        JSONArray idsMenus = new JSONArray();
        bd.execute( Constants.Listar,
                Constants.Tabla_MenuTicket,
                Constants.Tabla_MenuTicket_ticket+"="+idTicket+"");
        try {
            idsMenus= bd.get();
            if (idsMenus == null){
                return null;
            }

            //obtener menus de los ID
            if (idsMenus.length()>0){
                String ids= "";
                for (int i =0; i<idsMenus.length(); i++){
                    JSONObject idMenu = idsMenus.getJSONObject(i);
                    ids+=idMenu.getString("id_menu")+",";
                }

                ids = ids.substring(0, ids.length()-1);

                bd = new ConexionBD();
                bd.execute( Constants.Listar,
                        Constants.Tabla_Menus,
                        Constants.Tabla_Menus_ID+"="+ids+"");
                JSONArray menus = bd.get();
                menus=bd.get();

                for (int i =0; i<idsMenus.length(); i++){
                    JSONObject idMenu = idsMenus.getJSONObject(i);
                    for (int j =0; j<menus.length(); j++) {
                        JSONObject menu = menus.getJSONObject(j);
                        if (menu.getString("id_menu").equals(idMenu.getString("id_menu"))) {
                            idMenu.put("nombre", menu.getString("nombre"));
                            idMenu.put("precio", menu.getString("precio"));
                        }
                    }
                }

                //obtener articulos de los ID
                ids= "";
                for (int i =0; i<idsMenus.length(); i++){
                    JSONObject idMenu = idsMenus.getJSONObject(i);
                    ids+=idMenu.getString("id_primero")+","+
                            idMenu.getString("id_segundo")+","+
                            idMenu.getString("id_postre")+","+
                            idMenu.getString("id_bebida")+",";
                }

                ids = ids.substring(0, ids.length()-1);

                bd = new ConexionBD();
                bd.execute( Constants.Listar,
                        Constants.Tabla_Articulos,
                        Constants.Tabla_Articulos_ID+"="+ids+"");
                JSONArray articulos = bd.get();
                articulos=bd.get();

                for (int i =0; i<idsMenus.length(); i++){
                    JSONObject idMenu = idsMenus.getJSONObject(i);
                    for (int j =0; j<articulos.length(); j++) {
                        JSONObject articulo = articulos.getJSONObject(j);
                        if (articulo.getString("id_articulo").equals(idMenu.getString("id_primero"))) {
                            idMenu.put("primero", articulo.getString("nombre"));
                        }
                        if (articulo.getString("id_articulo").equals(idMenu.getString("id_segundo"))) {
                            idMenu.put("segundo", articulo.getString("nombre"));
                        }
                        if (articulo.getString("id_articulo").equals(idMenu.getString("id_postre"))) {
                            idMenu.put("postre", articulo.getString("nombre"));
                        }
                        if (articulo.getString("id_articulo").equals(idMenu.getString("id_bebida"))) {
                            idMenu.put("bebida", articulo.getString("nombre"));
                        }
                    }
                }
            }
            else{
                idsMenus= new JSONArray();
            }
        }
        catch (InterruptedException e) {
            e.printStackTrace();
        }
        catch (ExecutionException e) {
            e.printStackTrace();
        }
        catch (JSONException e){
            e.printStackTrace();
        }

        return idsMenus;
    }

    public JSONArray obtenerArticulosCartaTicket(String idTicket){
        JSONArray idsArticulos = new JSONArray();
        bd.execute( Constants.Listar,
                    Constants.Tabla_ArticulosTicket,
                    Constants.Tabla_ArticulosTicket_ticket+"='"+idTicket+"'");
        try {
            idsArticulos = bd.get();
            if (idsArticulos== null){
                return null;
            }
            if (idsArticulos.length()>0){
                String ids= "";
                for (int i =0; i<idsArticulos.length(); i++){
                    JSONObject idArticulo = idsArticulos.getJSONObject(i);
                    ids+=idArticulo.getString("id_articulo")+",";
                }

                ids = ids.substring(0, ids.length()-1);

                bd = new ConexionBD();
                bd.execute( Constants.Listar,
                        Constants.Tabla_Articulos,
                        Constants.Tabla_Articulos_ID+"="+ids);
                JSONArray articulos = bd.get();
                articulos=bd.get();

                for (int i =0; i<idsArticulos.length(); i++){
                    JSONObject idArticulo = idsArticulos.getJSONObject(i);
                    for (int j =0; j<articulos.length(); j++) {
                        JSONObject articulo = articulos.getJSONObject(j);
                        if (articulo.getString("id_articulo").equals(idArticulo.getString("id_articulo"))) {
                            idArticulo.put("nombre", articulo.getString("nombre"));
                            idArticulo.put("precio", articulo.getString("precio"));
                        }
                    }
                }
            }
            else{
                idsArticulos=new JSONArray();
            }

        }
        catch (InterruptedException e) {
            e.printStackTrace();
        }
        catch (ExecutionException e) {
            e.printStackTrace();
        }
        catch (JSONException e){
            e.printStackTrace();
        }

        return idsArticulos;
    }

    public void eliminarMenuTicket(String idTicketMenu){
        bd.execute( Constants.Eliminar,
                    Constants.Tabla_MenuTicket,
                    Constants.Tabla_MenuTicket_ID+"="+idTicketMenu+"");
    }

    public void eliminarArticuloTicket(String idTicketArticulo){
        bd.execute( Constants.Eliminar,
                    Constants.Tabla_ArticulosTicket,
                    Constants.Tabla_ArticulosTicket_ID+"="+idTicketArticulo+"");
    }

    public JSONArray obtenerMenusRestaurante(String idRestaurante){
        JSONArray resultado = new JSONArray();
        bd.execute( Constants.Listar,
                    Constants.Tabla_Menus,
                    Constants.Tabla_Menus_restaurante+"='"+idRestaurante+"'"
                            +"&"+
                    Constants.Tabla_Menus_eliminado+"='False'");
        try {
            resultado = bd.get();
        }
        catch (InterruptedException e) {
            e.printStackTrace();
        }
        catch (ExecutionException e) {
            e.printStackTrace();
        }
        return resultado;
    }

    public JSONArray obtenerArticulosdeRestaurante(String idRestaurante){
        JSONArray resultado = new JSONArray();
        bd.execute( Constants.Listar,
                Constants.Tabla_Articulos,
                Constants.Tabla_Articulos_restaurante+"='"+idRestaurante+"'"
                        +"&"+
                Constants.Tabla_Articulos_eliminado+"='False'");

        try {
            resultado = bd.get();
        }
        catch (InterruptedException e) {
            e.printStackTrace();
        }
        catch (ExecutionException e) {
            e.printStackTrace();
        }
        return resultado;
    }

    public JSONArray obtenerArticulosdeRestaurantePorTipoArticuloYMenu(String idRestaurante,String tipoArticulo,String idMenu){
        JSONArray resultado = new JSONArray();
        try {
            bd.execute( Constants.Listar,
                        Constants.Tabla_ArticulosMenu,
                        Constants.Tabla_ArticulosMenu_ID_menu+"='"+idMenu+"'");
            JSONArray articulos = bd.get();
            if (articulos == null){
                return null;
            }
            String idsArticulos ="";
            for(int i = 0; i<articulos.length(); i++){
                idsArticulos += articulos.getJSONObject(i).getString("id_articulo")+",";
            }
            idsArticulos = idsArticulos.substring(0, idsArticulos.length()-1);

            bd = new ConexionBD();
            bd.execute( Constants.Listar,
                    Constants.Tabla_Articulos,
                    Constants.Tabla_Articulos_ID+"="+idsArticulos+""
                            +"&"+
                    Constants.Tabla_Articulos_tipo_articulo+"='"+tipoArticulo+"'"
                            +"&"+
                    Constants.Tabla_Articulos_eliminado+"='False'");

            resultado = bd.get();
        }
        catch (InterruptedException e) {
            e.printStackTrace();
        }
        catch (ExecutionException e) {
            e.printStackTrace();
        }
        catch (JSONException e) {
            e.printStackTrace();
        }
        return resultado;
    }

    public JSONArray obtenerArticulosdeRestaurantePorNombre(String idRestaurante,String nombreArticulo){
        JSONArray resultado = new JSONArray();
        bd.execute( Constants.Listar,
                Constants.Tabla_Articulos,
                Constants.Tabla_Articulos_restaurante+"='"+idRestaurante+"'"
                        +"&"+
                Constants.Tabla_Articulos_nombre+"='"+nombreArticulo+"'"
                        +"&"+
                Constants.Tabla_Articulos_eliminado+"='False'");

        try {
            resultado = bd.get();
        }
        catch (InterruptedException e) {
            e.printStackTrace();
        }
        catch (ExecutionException e) {
            e.printStackTrace();
        }
        return resultado;
    }

    public JSONArray obtenerFotoDelArticulo(String idFoto){
        JSONArray resultado = new JSONArray();
        bd.execute( Constants.Listar,
                    Constants.Tabla_Foto,
                    Constants.Tabla_Foto_ID+"='"+idFoto+"'");

        try {
            resultado = bd.get();
        }
        catch (InterruptedException e) {
            e.printStackTrace();
        }
        catch (ExecutionException e) {
            e.printStackTrace();
        }
        return resultado;
    }

    public void añadirArticuloTicket(String idTicket, String idArticulo){
        bd.execute( Constants.Insertar,
                    Constants.Tabla_ArticulosTicket,
                    Constants.Tabla_ArticulosTicket_articulo+"='"+idArticulo+"'",
                    Constants.Tabla_ArticulosTicket_ticket+"='"+idTicket+"'",
                    Constants.Tabla_ArticulosTicket_estado+"=pendiente de envio");
    }

    public void añadirMenuTicket(String idTicket,
                                 String idMenu,
                                 String idPrimero,
                                 String idSegundo,
                                 String idPostre,
                                 String idBebida){
        bd.execute( Constants.Insertar,
                    Constants.Tabla_MenuTicket,
                    Constants.Tabla_MenuTicket_menu+"='"+idMenu+"'",
                    Constants.Tabla_MenuTicket_ticket+"='"+idTicket+"'",
                    Constants.Tabla_MenuTicket_estado+"=pendiente de envio",
                    Constants.Tabla_MenuTicket_primero+"='"+idPrimero+"'",
                    Constants.Tabla_MenuTicket_segundo+"='"+idSegundo+"'",
                    Constants.Tabla_MenuTicket_postre+"='"+idPostre+"'",
                    Constants.Tabla_MenuTicket_bebida+"='"+idBebida+"'");
    }

    public void modificarMenuTicket(String idTicketMenu,
                                    String tipoPlato,
                                    String idPlato) {
        String tipo = "";
        if(tipoPlato.equals("Primero")){
            tipo = Constants.Tabla_MenuTicket_primero;
        }
        else if(tipoPlato.equals("Segundo")){
            tipo = Constants.Tabla_MenuTicket_segundo;
        }
        else if(tipoPlato.equals("Postre")){
            tipo = Constants.Tabla_MenuTicket_postre;
        }
        else if(tipoPlato.equals("Bebida")){
            tipo = Constants.Tabla_MenuTicket_bebida;
        }
        bd.execute( Constants.Actualizar,
                    Constants.Tabla_MenuTicket,
                    Constants.Tabla_MenuTicket_ID+"='"+idTicketMenu+"'",
                    tipo+"='"+idPlato+"'");
    }

    public JSONArray obtenerHistoricoDelUsuario(String idUsuario){
        JSONArray tickets = new JSONArray();
        bd.execute( Constants.Listar,
                    Constants.Tabla_Tickets,
                    Constants.Tabla_Tickets_usuario+"='"+idUsuario+"'"
                        +"&"+
                    Constants.Tabla_Tickets_abierto+"='False'");

        try {
            tickets = bd.get();
            if (tickets == null){
                return null;
            }

            if (tickets.length()>0) {
                String ids = "";
                for (int i = 0; i < tickets.length(); i++) {
                    JSONObject ticket = tickets.getJSONObject(i);
                    ids += ticket.getString("id_restaurante") + ",";
                }

                ids = ids.substring(0, ids.length() - 1);

                bd = new ConexionBD();
                bd.execute(Constants.Listar,
                        Constants.Tabla_Restaurantes,
                        Constants.Tabla_Restaurantes_nombre+ "=" + ids + "");
                JSONArray restaurantes = bd.get();

                for (int i = 0; i < tickets.length(); i++) {
                    JSONObject ticket = tickets.getJSONObject(i);
                    for (int j = 0; j < restaurantes.length(); j++) {
                        JSONObject restaurante = restaurantes.getJSONObject(j);
                        if (restaurante.getString("id_restaurante").equals(ticket.getString("id_restaurante"))) {
                            ticket.put("nombreRestaurante", restaurante.getString("nombre"));
                        }
                    }
                }
            }
            else{
                tickets= new JSONArray();
            }
        }
        catch (InterruptedException e) {
            e.printStackTrace();
        }
        catch (ExecutionException e) {
            e.printStackTrace();
        }
        catch (JSONException e){
            e.printStackTrace();
        }
        return tickets;
    }

    public void eliminarTicket(String idTicket){
        bd.execute( Constants.Eliminar,
                    Constants.Tabla_Tickets,
                    Constants.Tabla_Tickets_ID+"="+idTicket);
    }

    public void solicitarPagoTicket(String idTicket){
        bd.execute( Constants.Actualizar,
                    Constants.Tabla_Tickets,
                    Constants.Tabla_Tickets_ID+"="+idTicket,
                    Constants.Tabla_Tickets_pago+"=solicitado");
    }

    public void pedirArticulosPendientes(String idTicket){
        //obtener articulos con el estado de pendiente de envio
        bd.execute( Constants.Listar,
                    Constants.Tabla_ArticulosTicket,
                    Constants.Tabla_ArticulosTicket_ticket+"="+idTicket
                            +"&"+
                    Constants.Tabla_ArticulosTicket_estado+"='pendiente de envio'");
        try {
            JSONArray articulosTicket = bd.get();
            //cambiar a pendiente de confirmacion
            for (int i = 0; i<articulosTicket.length(); i++){
                JSONObject articuloTicket = articulosTicket.getJSONObject(i);
                bd = new ConexionBD();
                bd.execute( Constants.Actualizar,
                            Constants.Tabla_ArticulosTicket,
                            Constants.Tabla_ArticulosTicket_ID+"="+articuloTicket.getString("id_ticket_articulo"),
                            Constants.Tabla_ArticulosTicket_estado+"=pendiente de confirmacion");
            }
        } catch (InterruptedException e) {
            e.printStackTrace();
        } catch (ExecutionException e) {
            e.printStackTrace();
        } catch (JSONException e){
            e.printStackTrace();
        }
        bd = new ConexionBD();
        //obtener menus con el estado de pendiente de envio
        bd.execute( Constants.Listar,
                    Constants.Tabla_MenuTicket,
                    Constants.Tabla_MenuTicket_ticket+"="+idTicket
                        +"&"+
                    Constants.Tabla_MenuTicket_estado+"='pendiente de envio'");
        try {
            JSONArray menusTicket = bd.get();
            //cambiar a pendiente de confirmacion
            for (int i = 0; i<menusTicket.length(); i++){
                JSONObject menuTicket = menusTicket.getJSONObject(i);
                bd = new ConexionBD();
                bd.execute( Constants.Actualizar,
                        Constants.Tabla_MenuTicket,
                        Constants.Tabla_MenuTicket_ID+"="+menuTicket.getString("id_ticket_menu"),
                        Constants.Tabla_MenuTicket_estado+"=pendiente de confirmacion");
            }
        } catch (InterruptedException e) {
            e.printStackTrace();
        } catch (ExecutionException e) {
            e.printStackTrace();
        } catch (JSONException e){
            e.printStackTrace();
        }
    }
}
