package com.fastservice.app.conections;

import android.os.AsyncTask;
import android.util.Log;

import com.fastservice.app.utils.Constants;

import org.apache.http.HttpEntity;
import org.apache.http.HttpResponse;
import org.apache.http.NameValuePair;
import org.apache.http.client.HttpClient;
import org.apache.http.client.entity.UrlEncodedFormEntity;
import org.apache.http.client.methods.HttpDelete;
import org.apache.http.client.methods.HttpGet;
import org.apache.http.client.methods.HttpPost;
import org.apache.http.client.methods.HttpPut;
import org.apache.http.conn.ConnectTimeoutException;
import org.apache.http.impl.client.DefaultHttpClient;
import org.apache.http.message.BasicNameValuePair;
import org.apache.http.params.BasicHttpParams;
import org.apache.http.params.HttpConnectionParams;
import org.apache.http.params.HttpParams;
import org.apache.http.util.EntityUtils;
import org.json.JSONArray;
import org.json.JSONException;

import java.io.IOException;
import java.util.ArrayList;

/**
 * Created by JonAnder
 */

public class ConexionBD extends AsyncTask<String, Void, JSONArray> {
    private String accion;
    private String tabla;
    private String url;

    public ConexionBD(){
    }

    protected void onPreExecute() {
        super.onPreExecute();
    }

    protected JSONArray doInBackground(String... params) {
        JSONArray jsonArray = new JSONArray();
        try {
            //Creamos la peticion HTTP a enviar al servicio web con sus parametros
            HttpParams httpParameters = new BasicHttpParams();
            HttpConnectionParams.setConnectionTimeout(httpParameters, 5000);
            HttpConnectionParams.setSoTimeout(httpParameters, 5000);
            HttpClient httpclient = new DefaultHttpClient(httpParameters);

            accion = params[0];
            tabla = params[1];
            url = Constants.Servidor+tabla;

            HttpResponse response = null;
            if(accion=="get"){
                if (params.length > 2){
                    url = url + "/" + params[2];
                }
                url=url.replaceAll(" ","%20");
                Log.i("url",url);
                HttpGet httpget = new HttpGet(url);
                response = httpclient.execute(httpget);
            }
            else if (accion=="post"){
                ArrayList<NameValuePair> parametros = new ArrayList<NameValuePair>();
                for (int i = 2; i < params.length; i++) {
                    String campo = params[i].split("=")[0];
                    String valor = params[i].split("=")[1];
                    parametros.add(new BasicNameValuePair(campo, valor));
                }
                url=url.replaceAll(" ","%20");
                HttpPost httppost = new HttpPost(url);
                httppost.setEntity(new UrlEncodedFormEntity(parametros));
                response = httpclient.execute(httppost);
            }
            else if (accion=="put"){
                ArrayList<NameValuePair> parametros = new ArrayList<NameValuePair>();
                for (int i = 2; i < params.length; i++) {
                    String campo = params[i].split("=")[0];
                    String valor = params[i].split("=")[1];
                    parametros.add(new BasicNameValuePair(campo, valor));
                }
                url=url.replaceAll(" ","%20");
                HttpPut httpput = new HttpPut(url);
                httpput.setEntity(new UrlEncodedFormEntity(parametros));
                response = httpclient.execute(httpput);

            }
            else if (accion=="delete"){
                if (params.length > 2){
                    url = url + "/" + params[2];
                }
                url=url.replaceAll(" ","%20");
                HttpDelete httpdelete = new HttpDelete(url);
                response = httpclient.execute(httpdelete);
            }

            HttpEntity entity = response.getEntity();
            String result = EntityUtils.toString(entity);
            Log.i("AccesoExternoBD", "result: "+result);
            jsonArray = new JSONArray(result);

        } catch (ConnectTimeoutException e)
        {
            Log.i("Soy un timeout",":)");
            jsonArray = null;
            e.printStackTrace();
        }catch (IOException e) {
            e.printStackTrace();
            Log.e("ConexionBD", "IOException Lanzada");
        } catch (JSONException e) {
            e.printStackTrace();
            Log.e("ConexionBD", "JSONException Lanzada");
        }
        return jsonArray;
    }

    protected void onPostExecute(JSONArray rdo) {
        super.onPostExecute(rdo);
    }



}

