package com.fastservice.app.model;

/**
 * Created by JonAnder.
*/
import java.util.List;
import java.util.Map;
import android.app.Activity;
import android.app.AlertDialog;
import android.content.Context;
import android.content.DialogInterface;
import android.graphics.Typeface;
import android.util.Log;
import android.view.LayoutInflater;
import android.view.View;
import android.view.View.OnClickListener;
import android.view.ViewGroup;
import android.widget.BaseExpandableListAdapter;
import android.widget.ImageView;
import android.widget.TextView;

import com.fastservice.app.R;

public class ExpandableListAdapter extends BaseExpandableListAdapter {

    private Activity context;
    private Map<String, List<String>> tiposArticulo;
    private List<String> articulos;

    public ExpandableListAdapter(Activity context, List<String> articulos,
                                 Map<String, List<String>> tiposArticulo) {
        this.context = context;
        this.tiposArticulo = tiposArticulo;
        this.articulos = articulos;
    }

    public Object getChild(int posicionGrupo, int posicion) {
        return tiposArticulo.get(articulos.get(posicionGrupo)).get(posicion);
    }

    public long getChildId(int posicionGrupo, int posicionHijo) {
        return posicionHijo;
    }


    public View getChildView(final int podicionGrupo, final int posicionHijo,
                             boolean isLastChild, View convertView, ViewGroup parent) {
        final String articulo = (String) getChild(podicionGrupo, posicionHijo);
        LayoutInflater inflater = context.getLayoutInflater();

        if (convertView == null) {
            convertView = inflater.inflate(R.layout.expansable_list_child_item, null);
        }

        TextView item = (TextView) convertView.findViewById(R.id.nombre_articulo);

        item.setText(articulo);
        return convertView;
    }

    public int getChildrenCount(int posicionGrupo) {
        return tiposArticulo.get(articulos.get(posicionGrupo)).size();
    }

    public Object getGroup(int posicionGrupo) {
        return articulos.get(posicionGrupo);
    }

    public int getGroupCount() {
        return articulos.size();
    }

    public long getGroupId(int posicionGrupo) {
        return posicionGrupo;
    }

    public View getGroupView(int posicionGrupo, boolean isExpanded,
                             View convertView, ViewGroup parent) {
        String laptopName = (String) getGroup(posicionGrupo);
        if (convertView == null) {
            LayoutInflater infalInflater = (LayoutInflater) context
                    .getSystemService(Context.LAYOUT_INFLATER_SERVICE);
            convertView = infalInflater.inflate(R.layout.expansable_list_group_item,
                    null);
        }
        TextView item = (TextView) convertView.findViewById(R.id.tipo_articulo);
        item.setTypeface(null, Typeface.BOLD);
        item.setText(laptopName);
        return convertView;
    }

    public boolean hasStableIds() {
        return true;
    }

    public boolean isChildSelectable(int posicionGrupo, int childPosition) {
        return true;
    }
}
