package com.fastservice.app.utils;

import android.app.AlertDialog;
import android.content.Context;
import android.content.DialogInterface;
import android.content.SharedPreferences;
import android.widget.Toast;

import com.fastservice.app.conections.BD;

import java.security.MessageDigest;
import java.security.NoSuchAlgorithmException;

/**
 * Created by JonAnder on 13/05/2014.
 */
public class Utils {

    public static String getPasswordHash(String password){
        try {
            // Create MD5 Hash
            MessageDigest digest = MessageDigest.getInstance("MD5");
            digest.update(password.getBytes());
            byte messageDigest[] = digest.digest();

            // Create Hex String
            StringBuffer hexString = new StringBuffer();
            for (int i=0; i<messageDigest.length; i++)
                hexString.append(Integer.toHexString(0xFF & messageDigest[i]));
            return hexString.toString();

        } catch (NoSuchAlgorithmException e) {
            e.printStackTrace();
        }
        return "";
    }

    public static void login(Context context, String user){

        SharedPreferences pref = context.getSharedPreferences("FastServicePref", 0); // 0 - for private mode
        SharedPreferences.Editor editor = pref.edit();

        editor.putString("user", user);
        editor.commit();
    }

    public static void logout(Context context){
        SharedPreferences pref = context.getSharedPreferences("FastServicePref", 0); // 0 - for private mode
        String usuario = pref.getString("user",null);
        SharedPreferences.Editor editor = pref.edit();
        editor.remove("user");
        editor.commit();
        BD bd = new BD();
        bd.actualizarGcmUsuario(usuario,"No_GCM_Key");
    }

    public static String getLoggedUser(Context context){
        SharedPreferences pref = context.getSharedPreferences("FastServicePref", 0); // 0 - for private mode
        return pref.getString("user", null);
    }

    public static String getLoggedUserGcmKey(Context context){
        SharedPreferences pref = context.getSharedPreferences("FastServicePref", 0); // 0 - for private mode
        return pref.getString("registration_id", null);
    }

    public static void showToast(Context context,String message){
        Toast.makeText(context, message, Toast.LENGTH_LONG).show();
    }

    public static void showTimeoutAlert(Context context){
        AlertDialog alertDialog = new AlertDialog.Builder(context).create();
        // Setting Dialog Title
        alertDialog.setTitle("Error de conexión");
        // Setting Dialog Message
        alertDialog.setMessage("\"Es necesario que el dispositivo este conectado a internet. A continuacion la aplicacion se cerrara\"");
        alertDialog.setButton("OK", new DialogInterface.OnClickListener() {
            public void onClick(DialogInterface dialog,int which)
            {
                System.exit(0);
            }
        });
        alertDialog.show();
    };

    public static void guardarInformacionPlato(Context context,String tipo_plato,String id_plato){
        SharedPreferences pref = context.getSharedPreferences("FastServicePref", 0); // 0 - for private mode
        SharedPreferences.Editor editor = pref.edit();
        editor.putString(tipo_plato, id_plato);
        editor.commit();
    }

    public static String obtenerInformacionPlato(Context context,String tipo_plato){
        SharedPreferences pref = context.getSharedPreferences("FastServicePref", 0); // 0 - for private mode
        return pref.getString(tipo_plato, null);
    }
}
