-- phpMyAdmin SQL Dump
-- version 3.4.11.1deb2+deb7u1
-- http://www.phpmyadmin.net
--
-- Servidor: localhost
-- Tiempo de generación: 08-09-2014 a las 12:40:24
-- Versión del servidor: 5.5.38
-- Versión de PHP: 5.4.4-14+deb7u12

SET SQL_MODE="NO_AUTO_VALUE_ON_ZERO";
SET time_zone = "+00:00";


/*!40101 SET @OLD_CHARACTER_SET_CLIENT=@@CHARACTER_SET_CLIENT */;
/*!40101 SET @OLD_CHARACTER_SET_RESULTS=@@CHARACTER_SET_RESULTS */;
/*!40101 SET @OLD_COLLATION_CONNECTION=@@COLLATION_CONNECTION */;
/*!40101 SET NAMES utf8 */;

--
-- Base de datos: `fastservice`
--

-- --------------------------------------------------------

--
-- Estructura de tabla para la tabla `articulo`
--

CREATE TABLE IF NOT EXISTS `articulo` (
  `id_articulo` int(11) NOT NULL AUTO_INCREMENT,
  `id_restaurante` int(11) NOT NULL,
  `nombre` varchar(45) NOT NULL,
  `descripcion` varchar(300) NOT NULL,
  `precio` decimal(10,2) NOT NULL,
  `tipo_articulo` varchar(45) NOT NULL COMMENT 'Primero,Segundo,Postre,Bebida,Entremeses.',
  `foto` int(11) DEFAULT NULL,
  `eliminado` varchar(45) NOT NULL DEFAULT 'False',
  PRIMARY KEY (`id_articulo`),
  KEY `id_restaurante` (`id_restaurante`),
  KEY `foto` (`foto`)
) ENGINE=InnoDB  DEFAULT CHARSET=utf8 AUTO_INCREMENT=64 ;

-- --------------------------------------------------------

--
-- Estructura de tabla para la tabla `articulo_menu`
--

CREATE TABLE IF NOT EXISTS `articulo_menu` (
  `id_articulo` int(11) NOT NULL,
  `id_menu` int(11) NOT NULL,
  PRIMARY KEY (`id_articulo`,`id_menu`),
  KEY `id_menu` (`id_menu`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8;

-- --------------------------------------------------------

--
-- Estructura de tabla para la tabla `foto`
--

CREATE TABLE IF NOT EXISTS `foto` (
  `id_foto` int(11) NOT NULL AUTO_INCREMENT,
  `foto` varchar(300) NOT NULL,
  PRIMARY KEY (`id_foto`)
) ENGINE=InnoDB  DEFAULT CHARSET=utf8 AUTO_INCREMENT=30 ;

-- --------------------------------------------------------

--
-- Estructura de tabla para la tabla `menu`
--

CREATE TABLE IF NOT EXISTS `menu` (
  `id_menu` int(11) NOT NULL AUTO_INCREMENT,
  `id_restaurante` int(11) NOT NULL,
  `nombre` varchar(45) NOT NULL,
  `descripcion` varchar(300) NOT NULL,
  `precio` decimal(10,2) NOT NULL,
  `eliminado` varchar(45) NOT NULL DEFAULT 'False',
  PRIMARY KEY (`id_menu`),
  KEY `idrestaurante_idx` (`id_restaurante`)
) ENGINE=InnoDB  DEFAULT CHARSET=utf8 AUTO_INCREMENT=8 ;

-- --------------------------------------------------------

--
-- Estructura de tabla para la tabla `mesa`
--

CREATE TABLE IF NOT EXISTS `mesa` (
  `id_mesa` int(11) NOT NULL,
  `id_restaurante` int(11) NOT NULL,
  `capacidad` int(11) NOT NULL,
  PRIMARY KEY (`id_mesa`,`id_restaurante`),
  KEY `id_restaurante_idx` (`id_restaurante`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8;

-- --------------------------------------------------------

--
-- Estructura de tabla para la tabla `restaurante`
--

CREATE TABLE IF NOT EXISTS `restaurante` (
  `id_restaurante` int(11) NOT NULL AUTO_INCREMENT,
  `administrador` varchar(45) NOT NULL,
  `nombre` varchar(45) NOT NULL,
  `descripcion` varchar(300) NOT NULL,
  `logo` int(11) DEFAULT NULL,
  PRIMARY KEY (`id_restaurante`),
  UNIQUE KEY `logo` (`logo`),
  KEY `id_administrador_idx` (`administrador`)
) ENGINE=InnoDB  DEFAULT CHARSET=utf8 AUTO_INCREMENT=5 ;

-- --------------------------------------------------------

--
-- Estructura de tabla para la tabla `ticket`
--

CREATE TABLE IF NOT EXISTS `ticket` (
  `id_ticket` int(11) NOT NULL AUTO_INCREMENT,
  `id_mesa` int(11) NOT NULL,
  `usuario` varchar(45) NOT NULL,
  `id_restaurante` int(11) NOT NULL,
  `fecha` datetime NOT NULL,
  `precio` decimal(10,2) NOT NULL,
  `abierto` varchar(45) NOT NULL COMMENT 'True,False',
  `numero_ticket` int(11) NOT NULL,
  `pago` varchar(45) NOT NULL COMMENT 'pendiente,solicitado,pagado',
  PRIMARY KEY (`id_ticket`),
  KEY `id_usuario_idx` (`usuario`),
  KEY `id_mesa_idx` (`id_mesa`),
  KEY `id_restaurante_idx` (`id_restaurante`)
) ENGINE=InnoDB  DEFAULT CHARSET=utf8 AUTO_INCREMENT=19 ;

-- --------------------------------------------------------

--
-- Estructura de tabla para la tabla `ticket_articulo`
--

CREATE TABLE IF NOT EXISTS `ticket_articulo` (
  `id_ticket_articulo` int(11) NOT NULL AUTO_INCREMENT,
  `id_ticket` int(11) NOT NULL,
  `id_articulo` int(11) NOT NULL,
  `estado` varchar(45) NOT NULL COMMENT 'pendiente de envio, pendiente de confirmacion, atendido',
  PRIMARY KEY (`id_ticket_articulo`),
  KEY `id_ticket` (`id_ticket`),
  KEY `id_articulo` (`id_articulo`)
) ENGINE=InnoDB  DEFAULT CHARSET=utf8 AUTO_INCREMENT=97 ;

-- --------------------------------------------------------

--
-- Estructura de tabla para la tabla `ticket_menu`
--

CREATE TABLE IF NOT EXISTS `ticket_menu` (
  `id_ticket_menu` int(11) NOT NULL AUTO_INCREMENT,
  `id_ticket` int(11) NOT NULL,
  `id_menu` int(11) NOT NULL,
  `estado` varchar(45) NOT NULL COMMENT 'pendiente de atender, atendido,entregado',
  `id_primero` int(11) NOT NULL,
  `id_segundo` int(11) NOT NULL,
  `id_postre` int(11) NOT NULL,
  `id_bebida` int(11) NOT NULL,
  PRIMARY KEY (`id_ticket_menu`),
  KEY `id_ticket` (`id_ticket`),
  KEY `id_menu` (`id_menu`),
  KEY `id_primero` (`id_primero`),
  KEY `id_segundo` (`id_segundo`),
  KEY `id_postre` (`id_postre`),
  KEY `id_bebida` (`id_bebida`)
) ENGINE=InnoDB  DEFAULT CHARSET=utf8 AUTO_INCREMENT=19 ;

-- --------------------------------------------------------

--
-- Estructura de tabla para la tabla `usuario`
--

CREATE TABLE IF NOT EXISTS `usuario` (
  `nombre_usuario` varchar(45) NOT NULL,
  `nombre` varchar(45) NOT NULL,
  `apellido` varchar(45) NOT NULL,
  `password_hash` varchar(45) NOT NULL,
  `gcm_key` varchar(250) DEFAULT NULL,
  `tipo_usuario` varchar(45) NOT NULL COMMENT 'usuario,administrador',
  `email` varchar(70) NOT NULL,
  PRIMARY KEY (`nombre_usuario`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8;

--
-- Restricciones para tablas volcadas
--

--
-- Filtros para la tabla `articulo`
--
ALTER TABLE `articulo`
  ADD CONSTRAINT `articulo_ibfk_1` FOREIGN KEY (`foto`) REFERENCES `foto` (`id_foto`) ON DELETE SET NULL ON UPDATE CASCADE,
  ADD CONSTRAINT `articulo_ibfk_2` FOREIGN KEY (`id_restaurante`) REFERENCES `restaurante` (`id_restaurante`) ON DELETE CASCADE ON UPDATE CASCADE;

--
-- Filtros para la tabla `articulo_menu`
--
ALTER TABLE `articulo_menu`
  ADD CONSTRAINT `articulo_menu_ibfk_1` FOREIGN KEY (`id_menu`) REFERENCES `menu` (`id_menu`) ON DELETE CASCADE ON UPDATE CASCADE,
  ADD CONSTRAINT `articulo_menu_ibfk_2` FOREIGN KEY (`id_articulo`) REFERENCES `articulo` (`id_articulo`) ON DELETE CASCADE ON UPDATE CASCADE;

--
-- Filtros para la tabla `menu`
--
ALTER TABLE `menu`
  ADD CONSTRAINT `menu_ibfk_1` FOREIGN KEY (`id_restaurante`) REFERENCES `restaurante` (`id_restaurante`) ON DELETE CASCADE ON UPDATE CASCADE;

--
-- Filtros para la tabla `mesa`
--
ALTER TABLE `mesa`
  ADD CONSTRAINT `mesa_ibfk_1` FOREIGN KEY (`id_restaurante`) REFERENCES `restaurante` (`id_restaurante`) ON DELETE CASCADE ON UPDATE CASCADE;

--
-- Filtros para la tabla `restaurante`
--
ALTER TABLE `restaurante`
  ADD CONSTRAINT `restaurante_ibfk_1` FOREIGN KEY (`logo`) REFERENCES `foto` (`id_foto`) ON DELETE SET NULL ON UPDATE CASCADE,
  ADD CONSTRAINT `restaurante_ibfk_2` FOREIGN KEY (`administrador`) REFERENCES `usuario` (`nombre_usuario`) ON DELETE NO ACTION ON UPDATE CASCADE;

--
-- Filtros para la tabla `ticket`
--
ALTER TABLE `ticket`
  ADD CONSTRAINT `ticket_ibfk_1` FOREIGN KEY (`id_restaurante`) REFERENCES `restaurante` (`id_restaurante`) ON DELETE NO ACTION ON UPDATE CASCADE,
  ADD CONSTRAINT `ticket_ibfk_2` FOREIGN KEY (`usuario`) REFERENCES `usuario` (`nombre_usuario`) ON DELETE NO ACTION ON UPDATE CASCADE,
  ADD CONSTRAINT `ticket_ibfk_3` FOREIGN KEY (`id_mesa`) REFERENCES `mesa` (`id_mesa`) ON DELETE NO ACTION ON UPDATE CASCADE;

--
-- Filtros para la tabla `ticket_articulo`
--
ALTER TABLE `ticket_articulo`
  ADD CONSTRAINT `ticket_articulo_ibfk_1` FOREIGN KEY (`id_ticket`) REFERENCES `ticket` (`id_ticket`),
  ADD CONSTRAINT `ticket_articulo_ibfk_2` FOREIGN KEY (`id_articulo`) REFERENCES `articulo` (`id_articulo`);

--
-- Filtros para la tabla `ticket_menu`
--
ALTER TABLE `ticket_menu`
  ADD CONSTRAINT `ticket_menu_ibfk_1` FOREIGN KEY (`id_ticket`) REFERENCES `ticket` (`id_ticket`),
  ADD CONSTRAINT `ticket_menu_ibfk_2` FOREIGN KEY (`id_menu`) REFERENCES `menu` (`id_menu`),
  ADD CONSTRAINT `ticket_menu_ibfk_3` FOREIGN KEY (`id_primero`) REFERENCES `articulo` (`id_articulo`),
  ADD CONSTRAINT `ticket_menu_ibfk_4` FOREIGN KEY (`id_segundo`) REFERENCES `articulo` (`id_articulo`),
  ADD CONSTRAINT `ticket_menu_ibfk_5` FOREIGN KEY (`id_postre`) REFERENCES `articulo` (`id_articulo`),
  ADD CONSTRAINT `ticket_menu_ibfk_6` FOREIGN KEY (`id_bebida`) REFERENCES `articulo` (`id_articulo`);

/*!40101 SET CHARACTER_SET_CLIENT=@OLD_CHARACTER_SET_CLIENT */;
/*!40101 SET CHARACTER_SET_RESULTS=@OLD_CHARACTER_SET_RESULTS */;
/*!40101 SET COLLATION_CONNECTION=@OLD_COLLATION_CONNECTION */;
