﻿var express = require('express')
, http = require('http')
, mysql = require('mysql')
, path = require('path');
var app = express();

/// Include the express body parser
app.configure(function () {
  app.use(express.bodyParser());
});

// all environments
app.set('port', process.env.PORT || 3002);
app.set('views', __dirname + '/views');
app.set('view engine', 'jade');
app.use(function(req, res, next) {
    if (req.headers.origin) {
        res.header('Access-Control-Allow-Origin', '*')
        res.header('Access-Control-Allow-Headers', 'X-Requested-With,Content-Type,Authorization')
        res.header('Access-Control-Allow-Methods', 'GET,PUT,PATCH,POST,DELETE')
        if (req.method === 'OPTIONS') return res.send(200)
    }
    next()
})
app.use(express.favicon());
app.use(express.logger('dev'));
app.use(express.bodyParser());
app.use(express.methodOverride());
app.use(app.router);
app.use(express.static(path.join(__dirname, 'public')));

/// Include the node file module
var fs = require('fs');

/// Post files
app.post('/upload', function(req, res) {

  fs.readFile(req.files.image.path, function (err, data) {

    var imageName = req.files.image.name

    /// If there's an error
    if(!imageName){

      console.log("There was an error")
      res.redirect("/");
      res.end();

    } else {
      imageName = imageName.replace('ñ','n');
      imageName = imageName.replace('Ñ','N');
      var d = new Date();
      var fecha = ''+d.getFullYear()+'-'+(d.getMonth()+1)+'-'+d.getDate()+'_'+ d.getHours()+':'+d.getMinutes()+':'+d.getSeconds();

      var newPath = "/home/fonty/imagenes_FastService/" + fecha+ "_" +imageName;

      /// write file to uploads/fullsize folder
      fs.writeFile(newPath, data, function (err) {

        /// let's see it
        res.send('imagenes/'+fecha+ "_" +imageName);

      });
    }
  });
});

app.get('/', function ( req, res) {
res.render(' INdex');
});
//connect to mysql database
var connection = mysql.createConnection({
host : '192.168.1.200',
user : 'fonty',
password : 'jonan2201',
database : 'fastservice',
socketPath : '/var/run/mysqld/mysqld.sock'
}); 

//GCM
var gcm = require('node-gcm');
var message = new gcm.Message();
var sender = new gcm.Sender('AIzaSyBBhWxN0SwZ_kNZcmJF6DUsAq76Oy8uvgU');
var registrationIds = [];

//Envio GCM Message
app.get('/gcm/:usuario/:mensaje', function (req, res) {
  var usuario = req.params.usuario;
  var mensaje = req.params.mensaje; 
  connection.query('select gcm_key from usuario where nombre_usuario = "'+usuario+'"', function (err, docs) {
    if (err) {
      res.send(err);
    }
    else {
      message.addDataWithKeyValue('mensaje',mensaje);
      registrationIds = [];
      registrationIds.push(docs[0].gcm_key);
      sender.send(message, registrationIds, 4, function (err, result) {
        console.log(result);
      });
      res.send('Notificacion enviada');  
    }
  });
});

//Listado del contenido de las tablas
app.get('/usuarios', function (req, res) {
	connection.query('select * from usuario', function (err, docs) {
   		if (err) {
			res.send(err);
		}
   		else res.send(docs);	
	});
});

app.get('/tickets', function (req, res) {
	connection.query('select * from ticket', function (err, docs) {
   		if (err) res.send(err)
   		else res.send(docs);	
	});
});

app.get('/restaurantes', function (req, res) {
	connection.query('select * from restaurante', function (err, docs) {
   		if (err) res.send(err)
   		else res.send(docs);	
	});
});

app.get('/mesas', function (req, res) {
	connection.query('select * from mesa', function (err, docs) {
   		if (err) res.send(err)
   		else res.send(docs);	
	});
});

app.get('/menus', function (req, res) {
	connection.query('select * from menu', function (err, docs) {
   		if (err) res.send(err)
   		else res.send(docs);		
	});
});

app.get('/articulos', function (req, res) {
	connection.query('select * from articulo', function (err, docs) {
   		if (err) res.send(err)
   		else res.send(docs);	
	});
});

app.get('/fotos', function (req, res) {
  connection.query('select * from foto', function (err, docs) {
      if (err) res.send(err)
      else res.send(docs);  
  });
});



//Listado de contenido de las tablas dado un id
app.get("/usuarios/:optional?", function (req, res){
    var optional = req.params.optional;
        if(optional!="")
    {
      sql = 'select * from usuario where '
      var campo = optional.split("&")[0].split("=")[0];
      var valor = optional.split("&")[0].split("=")[1];
      if (valor.split(",").length==1){
        sql+= campo +'=' +valor;
      }
      else{
        sql+= campo +' IN (' + valor + ')' ;
      }

      for (var i = 1; i < optional.split("&").length; i++) {
        var campo = optional.split("&")[i].split("=")[0];
        var valor = optional.split("&")[i].split("=")[1];
        if (valor.split(",").length==1){
        sql+= ' AND '+ campo +'=' +valor;
        }
        else{
          sql+= ' AND '+ campo +' IN (' + valor + ')' ;
        }
      };
       	connection.query(sql, function (err, docs) {
       		if (err) res.send(err)
       		else res.send(docs);	
		});
    }
    //si hay algún error
    else
    {
        res.json(500,{"msg":"Error: parametro opcional no valido"});
    }   
});

app.get("/tickets/:optional?", function (req, res){
    var optional = req.params.optional;
        if(optional!="")
    {
      sql = 'select * from ticket where '
      var campo = optional.split("&")[0].split("=")[0];
      var valor = optional.split("&")[0].split("=")[1];
      if (valor.split(",").length==1){
        sql+= campo +'=' +valor;
      }
      else{
        sql+= campo +' IN (' + valor + ')' ;
      }

      for (var i = 1; i < optional.split("&").length; i++) {
        var campo = optional.split("&")[i].split("=")[0];
        var valor = optional.split("&")[i].split("=")[1];
        if (valor.split(",").length==1){
        sql+= ' AND '+ campo +'=' +valor;
        }
        else{
          sql+= ' AND '+ campo +' IN (' + valor + ')' ;
        }
      };
       	connection.query(sql, function (err, docs) {
       		if (err) res.send(err)
       		else res.send(docs);	
		});
    }
    //si hay algún error
    else
    {
        res.json(500,{"msg":"Error: parametro opcional no valido"});
    }
});

app.get("/restaurantes/:optional?", function (req,res){
    var optional = req.params.optional;
        if(optional!="")
    {
      sql = 'select * from restaurante where '
      var campo = optional.split("&")[0].split("=")[0];
      var valor = optional.split("&")[0].split("=")[1];
      if (valor.split(",").length==1){
        sql+= campo +'=' +valor;
      }
      else{
        sql+= campo +' IN (' + valor + ')' ;
      }

      for (var i = 1; i < optional.split("&").length; i++) {
        var campo = optional.split("&")[i].split("=")[0];
        var valor = optional.split("&")[i].split("=")[1];
        if (valor.split(",").length==1){
        sql+= ' AND '+ campo +'=' +valor;
        }
        else{
          sql+= ' AND '+ campo +' IN (' + valor + ')' ;
        }
      };
       	connection.query(sql, function (err, docs) {
       		if (err) res.send(err)
       		else res.send(docs);	
		});
    }
    //si hay algún error
    else
    {
        res.json(500,{"msg":"Error: parametro opcional no valido"});
    }
});

app.get("/mesas/:optional?", function (req,res){
    var optional = req.params.optional;
        if(optional!="")
    {
      sql = 'select * from mesa where '
      var campo = optional.split("&")[0].split("=")[0];
      var valor = optional.split("&")[0].split("=")[1];
      if (valor.split(",").length==1){
        sql+= campo +'=' +valor;
      }
      else{
        sql+= campo +' IN (' + valor + ')' ;
      }

      for (var i = 1; i < optional.split("&").length; i++) {
        var campo = optional.split("&")[i].split("=")[0];
        var valor = optional.split("&")[i].split("=")[1];
        if (valor.split(",").length==1){
        sql+= ' AND '+ campo +'=' +valor;
        }
        else{
          sql+= ' AND '+ campo +' IN (' + valor + ')' ;
        }
      };
       	connection.query(sql, function (err, docs) {
       		if (err) res.send(err)
       		else res.send(docs);	
		});
    }
    //si hay algún error
    else
    {
        res.json(500,{"msg":"Error: parametro opcional no valido"});
    }
});

app.get("/menus/:optional?", function (req,res){
    var optional = req.params.optional;
        if(optional!="")
    {
      sql = 'select * from menu where '
      var campo = optional.split("&")[0].split("=")[0];
      var valor = optional.split("&")[0].split("=")[1];
      if (valor.split(",").length==1){
        sql+= campo +'=' +valor;
      }
      else{
        sql+= campo +' IN (' + valor + ')' ;
      }

      for (var i = 1; i < optional.split("&").length; i++) {
        var campo = optional.split("&")[i].split("=")[0];
        var valor = optional.split("&")[i].split("=")[1];
        if (valor.split(",").length==1){
        sql+= ' AND '+ campo +'=' +valor;
        }
        else{
          sql+= ' AND '+ campo +' IN (' + valor + ')' ;
        }
      };
       	connection.query(sql, function (err, docs) {
       		if (err) res.send(err)
       		else res.send(docs);	
		});
    }
    //si hay algún error
    else
    {
        res.json(500,{"msg":"Error: parametro opcional no valido"});
    }
});

app.get("/menus/restaurante/:optional?", function (req,res){
    var optional = req.params.optional;
        if(optional!="")
    {
      sql = 'select * from menu where '
      var campo = optional.split("&")[0].split("=")[0];
      var valor = optional.split("&")[0].split("=")[1];
      if (valor.split(",").length==1){
        sql+= campo +'=' +valor;
      }
      else{
        sql+= campo +' IN (' + valor + ')' ;
      }

      for (var i = 1; i < optional.split("&").length; i++) {
        var campo = optional.split("&")[i].split("=")[0];
        var valor = optional.split("&")[i].split("=")[1];
        if (valor.split(",").length==1){
        sql+= ' AND '+ campo +'=' +valor;
        }
        else{
          sql+= ' AND '+ campo +' IN (' + valor + ')' ;
        }
      };
       	connection.query(sql, function (err, docs) {
       		if (err) res.send(err)
       		else res.send(docs);	
		});
    }
    //si hay algún error
    else
    {
        res.json(500,{"msg":"Error: parametro opcional no valido"});
    }
});

app.get("/articulos/:optional?", function (req,res){
    var optional = req.params.optional;
        if(optional!="")
    {
      sql = 'select * from articulo where '
      var campo = optional.split("&")[0].split("=")[0];
      var valor = optional.split("&")[0].split("=")[1];
      if (valor.split(",").length==1){
        sql+= campo +'=' +valor;
      }
      else{
        sql+= campo +' IN (' + valor + ')' ;
      }

      for (var i = 1; i < optional.split("&").length; i++) {
        var campo = optional.split("&")[i].split("=")[0];
        var valor = optional.split("&")[i].split("=")[1];
        if (valor.split(",").length==1){
        sql+= ' AND '+ campo +'=' +valor;
        }
        else{
          sql+= ' AND '+ campo +' IN (' + valor + ')' ;
        }
      };
       	connection.query(sql, function (err, docs) {
       		if (err) res.send(err)
       		else res.send(docs);	
		});
    }
    //si hay algún error
    else
    {
        res.json(500,{"msg":"Error: parametro opcional no valido"});
    }
});

app.get("/articulos/restaurante/:optional?", function (req,res){
    var optional = req.params.optional;
        if(optional!="")
    {
      sql = 'select * from articulo where '
      var campo = optional.split("&")[0].split("=")[0];
      var valor = optional.split("&")[0].split("=")[1];
      if (valor.split(",").length==1){
        sql+= campo +'=' +valor;
      }
      else{
        sql+= campo +' IN (' + valor + ')' ;
      }

      for (var i = 1; i < optional.split("&").length; i++) {
        var campo = optional.split("&")[i].split("=")[0];
        var valor = optional.split("&")[i].split("=")[1];
        if (valor.split(",").length==1){
        sql+= ' AND '+ campo +'=' +valor;
        }
        else{
          sql+= ' AND '+ campo +' IN (' + valor + ')' ;
        }
      };
       	connection.query(sql, function (err, docs) {
       		if (err) res.send(err)
       		else res.send(docs);	
		});
    }
    //si hay algún error
    else
    {
        res.json(500,{"msg":"Error: parametro opcional no valido"});
    }
});

app.get("/articulos_ticket/:optional?", function (req,res){
    var optional = req.params.optional;
        if(optional!="")
    {
      sql = 'select * from ticket_articulo where '
      var campo = optional.split("&")[0].split("=")[0];
      var valor = optional.split("&")[0].split("=")[1];
      if (valor.split(",").length==1){
        sql+= campo +'=' +valor;
      }
      else{
        sql+= campo +' IN (' + valor + ')' ;
      }

      for (var i = 1; i < optional.split("&").length; i++) {
        var campo = optional.split("&")[i].split("=")[0];
        var valor = optional.split("&")[i].split("=")[1];
        if (valor.split(",").length==1){
        sql+= ' AND '+ campo +'=' +valor;
        }
        else{
          sql+= ' AND '+ campo +' IN (' + valor + ')' ;
        }
      };
       	connection.query(sql, function (err, docs) {
       		if (err) res.send(err)
       		else res.send(docs);	
		});
    }
    //si hay algún error
    else
    {
        res.json(500,{"msg":"Error: parametro opcional no valido"});
    }
});

app.get("/menu_ticket/:optional?", function (req,res){
    var optional = req.params.optional;
        if(optional!="")
    {
      sql = 'select * from ticket_menu where '
      var campo = optional.split("&")[0].split("=")[0];
      var valor = optional.split("&")[0].split("=")[1];
      if (valor.split(",").length==1){
        sql+= campo +'=' +valor;
      }
      else{
        sql+= campo +' IN (' + valor + ')' ;
      }

      for (var i = 1; i < optional.split("&").length; i++) {
        var campo = optional.split("&")[i].split("=")[0];
        var valor = optional.split("&")[i].split("=")[1];
        if (valor.split(",").length==1){
        sql+= ' AND '+ campo +'=' +valor;
        }
        else{
          sql+= ' AND '+ campo +' IN (' + valor + ')' ;
        }
      };
       	connection.query(sql, function (err, docs) {
       		if (err) res.send(err)
       		else res.send(docs);	
		});
    }
    //si hay algún error
    else
    {
        res.json(500,{"msg":"Error: parametro opcional no valido"});
    }
});

app.get("/articulos_menu/:optional?", function (req,res){
    var optional = req.params.optional;
        if(optional!="")
    {
      sql = 'select * from articulo_menu where '
      var campo = optional.split("&")[0].split("=")[0];
      var valor = optional.split("&")[0].split("=")[1];
      if (valor.split(",").length==1){
        sql+= campo +'=' +valor;
      }
      else{
        sql+= campo +' IN (' + valor + ')' ;
      }

      for (var i = 1; i < optional.split("&").length; i++) {
        var campo = optional.split("&")[i].split("=")[0];
        var valor = optional.split("&")[i].split("=")[1];
        if (valor.split(",").length==1){
        sql+= ' AND '+ campo +'=' +valor;
        }
        else{
          sql+= ' AND '+ campo +' IN (' + valor + ')' ;
        }
      };
       	connection.query(sql, function (err, docs) {
       		if (err) res.send(err)
       		else res.send(docs);	
		});
    }
    //si hay algún error
    else
    {
        res.json(500,{"msg":"Error: parametro opcional no valido"});
    }
});

app.get("/fotos/:optional?", function (req, res){
    var optional = req.params.optional;
        if(optional!="")
    {
      sql = 'select * from foto where '
      var campo = optional.split("&")[0].split("=")[0];
      var valor = optional.split("&")[0].split("=")[1];
      if (valor.split(",").length==1){
        sql+= campo +'=' +valor;
      }
      else{
        sql+= campo +' IN (' + valor + ')' ;
      }

      for (var i = 1; i < optional.split("&").length; i++) {
        var campo = optional.split("&")[i].split("=")[0];
        var valor = optional.split("&")[i].split("=")[1];
        if (valor.split(",").length==1){
        sql+= ' AND '+ campo +'=' +valor;
        }
        else{
          sql+= ' AND '+ campo +' IN (' + valor + ')' ;
        }
      };
       	connection.query(sql, function (err, docs) {
          if (err) res.send(err)
          else res.send(docs);  
    });
    }
    //si hay algún error
    else
    {
        res.json(500,{"msg":"Error: parametro opcional no valido"});
    }   
});



//Insertar un elemento en la tabla
app.post("/usuarios", function (req,res){
	var nombre = req.body.nombre;
	var apellido = req.body.apellido;
	var nombre_usuario = req.body.nombre_usuario;
	var password_hash = req.body.password_hash;
	var gcm_key = req.body.gcm_key;
	var tipo_usuario = req.body.tipo_usuario;
  var email = req.body.email;
	var sql = ' INsert into usuario (nombre,apellido,nombre_usuario,password_hash,gcm_key,tipo_usuario,email) values (\"'+nombre+'\",\"'+apellido+'\",\"'+nombre_usuario+'\",\"'+password_hash+'\",\"'+gcm_key+'\",\"'+tipo_usuario+'\",\"'+email+'\")';
    connection.query(sql, function (err, docs) {
   		if (err) res.send(err)
   		else res.send(docs);	
	});
});

app.post("/tickets", function (req,res){
	var id_mesa = req.body.id_mesa;
	var usuario = req.body.usuario;
	var id_restaurante = req.body.id_restaurante;
  var d = new Date();
	var fecha = ''+d.getFullYear()+'-'+(d.getMonth()+1)+'-'+d.getDate()+' '+ d.getHours()+':'+d.getMinutes()+':'+d.getSeconds();
	var precio = req.body.precio;
	var abierto = req.body.abierto;
  var pago = req.body.pago;
  var num_ticket;
  connection.query('select MAX(numero_ticket) as numero from ticket where id_restaurante='+id_restaurante, function (err, docs) {
    if (err) {
      res.send(err);
    }
    num_ticket=parseInt(docs[0].numero);
    if (!isNaN(num_ticket)){
      num_ticket=num_ticket+1;
    }
    else{
      num_ticket=1;
    } 
    var sql = ' INsert into ticket (id_mesa,usuario,id_restaurante,fecha,precio,abierto,numero_ticket,pago) values('+id_mesa+',\"'+usuario+'\",'+id_restaurante+',\"'+fecha+'\",'+precio+',\"'+abierto+'\",'+num_ticket+',\"'+pago+'\")';
    connection.query(sql, function (err, docs) {
      if (err) res.send(err)
      else res.send(docs);  
  });
  });
	
});

app.post("/restaurantes", function (req,res){
	var administrador = req.body.administrador;
	var nombre = req.body.nombre;
	var descripcion = req.body.descripcion;
	var sql = ' INsert into restaurante (administrador,nombre,descripcion,logo) values (\"'+administrador+'\",\"'+nombre+'\",\"'+descripcion+'\",1)';
    connection.query(sql, function (err, docs) {
   		if (err) res.send(err)
   		else res.send(docs);	
	});
});

app.post("/mesas", function (req,res){
  var id_restaurante = req.body.id_restaurante;
  var capacidad = req.body.capacidad;
  var id_mesa;
   connection.query('select MAX(id_mesa) as numero from mesa where id_restaurante='+id_restaurante, function (err, docs) {
    if (err) {
      res.send(err);
    }
    id_mesa=parseInt(docs[0].numero); 
    if (!isNaN(id_mesa)){
      id_mesa=id_mesa+1;
    }
    else{
      id_mesa=0;
    }
    var sql = ' INsert into mesa (id_mesa,id_restaurante,capacidad) values ('+id_mesa+','+id_restaurante+','+capacidad+')';
    connection.query(sql, function (err, docs) {
      if (err) res.send(err)
      else res.send(docs);  
  });
  });
  
});

app.post("/menus", function (req,res){
	var id_restaurante = req.body.id_restaurante;
	var nombre = req.body.nombre;
  var descripcion = req.body.descripcion;
	var precio = req.body.precio;
	var sql = ' INsert into menu (id_restaurante,nombre,descripcion,precio) values ('+id_restaurante+',\"'+nombre+'\",\"'+descripcion+'\",'+precio+')';
    connection.query(sql, function (err, docs) {
   		if (err) res.send(err)
   		else res.send(docs);	
	});
});

app.post("/articulos", function (req,res){
	var id_restaurante = req.body.id_restaurante;
	var nombre = req.body.nombre;
	var descripcion = req.body.descripcion;
	var precio = req.body.precio;
	var tipo_articulo = req.body.tipo_articulo;
	var sql = ' INsert into articulo (id_restaurante,nombre,descripcion,precio,tipo_articulo,foto) values('+id_restaurante+',\"'+nombre+'\",\"'+descripcion+'\",'+precio+',\"'+tipo_articulo+'\",1)';
    connection.query(sql, function (err, docs) {
   		if (err) res.send(err)
   		else res.send(docs);	
	});
});

app.post("/articulos_ticket", function (req,res){
	var id_ticket = req.body.id_ticket;
	var id_articulo = req.body.id_articulo;
	var estado = req.body.estado;
	var sql = ' INsert into ticket_articulo (id_ticket,id_articulo,estado) values ('+id_ticket+','+id_articulo+',\"'+estado+'\")';
    connection.query(sql, function (err, docs) {
   		if (err) res.send(err)
   		else res.send(docs);	
	});
});

app.post("/menu_ticket", function (req,res){
	var id_ticket = req.body.id_ticket;
	var id_menu = req.body.id_menu;
	var estado = req.body.estado;
  var id_primero = req.body.id_primero;
  var id_segundo = req.body.id_segundo;
  var id_postre = req.body.id_postre;
  var id_bebida = req.body.id_bebida;
	var sql = ' INsert into ticket_menu (id_ticket,id_menu,estado,id_primero,id_segundo,id_postre,id_bebida) values ('+id_ticket+','+id_menu+',\"'+estado+'\",'+id_primero+','+id_segundo+','+id_postre+','+id_bebida+')';
    connection.query(sql, function (err, docs) {
   		if (err) res.send(err)
   		else res.send(docs);	
	});
});

app.post("/articulos_menu", function (req,res){
	var id_articulo = req.body.id_articulo;
	var id_menu = req.body.id_menu;
	var sql = ' INsert into articulo_menu (id_articulo,id_menu) values ('+id_articulo+','+id_menu+')';
    connection.query(sql, function (err, docs) {
   		if (err) res.send(err)
   		else res.send(docs);	
	});
});

app.post("/foto", function (req,res){
  var foto = req.body.foto;
  var sql = ' INsert into foto (foto) values (\"'+foto+'\")';
    connection.query(sql, function (err, docs) {
      if (err) res.send(err)
      else {
        sql2 = 'select * from foto where foto=\"'+foto+'\"';
      }; 
      connection.query(sql2, function (err, docs) {
        if (err) res.send(err)
        else res.send(docs); 
      });
    });
});



//Actualizar fila en la tabla dado un id
app.put("/usuarios", function (req,res){
	var nombre = req.body.nombre;
	var apellido = req.body.apellido;
	var nombre_usuario = req.body.nombre_usuario;
	var password_hash = req.body.password_hash;
	var gcm_key = req.body.gcm_key;
	var tipo_usuario = req.body.tipo_usuario;
  var email = req.body.email;
	var sql = 'update usuario set ';
  if (nombre){
    sql+= 'nombre=\"'+nombre+'\",';
  }
  if (apellido){
    sql+= 'apellido=\"'+apellido+'\",';
  }
  if (password_hash){
    sql+= 'password_hash=\"'+password_hash+'\",';
  }
  if (gcm_key){
    sql+= 'gcm_key=\"'+gcm_key+'\",';
  }
  if (email){
    sql+= 'email=\"'+email+'\",';
  }
  if (tipo_usuario){
    sql+= 'tipo_usuario=\"'+tipo_usuario+'\",';
  }
  sql = sql.substring(0, sql.length-1);
  sql += ' where nombre_usuario=\"'+nombre_usuario+'\"';
    connection.query(sql, function (err, docs) {
   		if (err) res.send(err)
   		else res.send(docs);	
	});
});

app.put("/tickets", function (req,res){
	var id_ticket = req.body.id_ticket;
	var id_mesa = req.body.id_mesa;
	var usuario = req.body.usuario;
	var id_restaurante = req.body.id_restaurante;
	var fecha = req.body.fecha;
	var precio = req.body.precio;
	var abierto = req.body.abierto;
  var pago = req.body.pago;
	var numero_ticket = req.body.numero_ticket;
	var sql = 'update ticket set ';
  if (id_mesa){
    sql+='id_mesa='+id_mesa+',';
  }
  if (usuario){
    sql+='usuario='+usuario+',';
  }
  if (id_restaurante){
    sql+='id_restaurante='+id_restaurante+',';
  }
  if (fecha){
    sql+='fecha=\"'+fecha+'\",';
  }
  if (precio){
    sql+='precio='+precio+',';
  }
  if (abierto){
    sql+='abierto=\"'+abierto+'\",';
  }
  if (numero_ticket){
    sql+='numero_ticket='+numero_ticket+',';
  }
  if (pago){
    sql+='pago=\"'+pago+'\",';
  }
  sql = sql.substring(0, sql.length-1);
  sql += ' where id_ticket = '+id_ticket;
    connection.query(sql, function (err, docs) {
   		if (err) res.send(err)
   		else res.send(docs);	
	});
});

app.put("/restaurantes", function (req,res){
	var id_restaurante = req.body.id_restaurante;
	var id_administrador = req.body.id_administrador;
	var nombre = req.body.nombre;
	var descripcion = req.body.descripcion;
  var logo = req.body.logo;
  var sql = 'update restaurante set ';
  if(id_administrador){
    sql+='id_administrador='+id_administrador+',';
  }
  if(nombre){
    sql+='nombre=\"'+nombre+'\",';
  }
  if(descripcion){
    sql+='descripcion=\"'+descripcion+'\",';
  }
  if(logo){
    sql+='logo='+logo+',';
  }
  sql = sql.substring(0, sql.length-1);
  sql+=' where id_restaurante='+id_restaurante;

    connection.query(sql, function (err, docs) {
   		if (err) res.send(err)
   		else res.send(docs);	
	});
});

app.put("/mesas", function (req,res){
  var id_mesa = req.body.id_mesa;
  var id_restaurante = req.body.id_restaurante;
  var capacidad = req.body.capacidad;
  var sql = 'update mesa set capacidad='+capacidad+' where id_mesa='+id_mesa+' AND id_restaurante='+id_restaurante;
    connection.query(sql, function (err, docs) {
      if (err) res.send(err)
      else res.send(docs);  
  });
});

app.put("/menus", function (req,res){
	var id_menu = req.body.id_menu;
	var id_restaurante = req.body.id_restaurante;
  var descripcion = req.body.descripcion;
	var nombre = req.body.nombre;
	var precio = req.body.precio;
  var eliminado = req.body.eliminado;
	var sql = 'update menu set ';
  if(id_restaurante){
    sql+='id_restaurante='+id_restaurante+',';
  }
  if(nombre){
    sql+='nombre=\"'+nombre+'\",';
  }
  if(descripcion){
    sql+='descripcion=\"'+descripcion+'\",';
  }
  if(precio){
    sql+='precio='+precio+',';
  }
  if(eliminado){
    sql+='eliminado=\"'+eliminado+'\",';
  }
  sql = sql.substring(0, sql.length-1);
  sql+=' where id_menu='+id_menu;
    connection.query(sql, function (err, docs) {
   		if (err) res.send(err)
   		else res.send(docs);	
	});
});

app.put("/articulos", function (req,res){
	var id_articulo = req.body.id_articulo;
	var id_restaurante = req.body.id_restaurante;
	var nombre = req.body.nombre;
	var descripcion = req.body.descripcion;
	var precio = req.body.precio;
	var tipo_articulo = req.body.tipo_articulo;
	var foto = req.body.foto;
  var eliminado = req.body.eliminado;
	var sql = 'update articulo set ';
  if(id_restaurante){
    sql+='id_restaurante'+id_restaurante+',';
  }
  if(nombre){
    sql+='nombre=\"'+nombre+'\",';
  }
  if(descripcion){
    sql+='descripcion=\"'+descripcion+'\",';
  }
  if(precio){
    sql+='precio='+precio+',';
  }
  if(tipo_articulo){
    sql+='tipo_articulo=\"'+tipo_articulo+'\",';
  }
  if(foto){
    sql+='foto=\"'+foto+'\",';
  }
  if(eliminado){
    sql+='eliminado=\"'+eliminado+'\",';
  }
  sql = sql.substring(0, sql.length-1);
  sql+=' where id_articulo='+id_articulo;
    connection.query(sql, function (err, docs) {
   		if (err) res.send(err)
   		else res.send(docs);	
	});
});

app.put("/articulos_ticket", function (req,res){
	var id_ticket_articulo = req.body.id_ticket_articulo;
	var estado = req.body.estado;
	var sql = 'update ticket_articulo set estado=\"'+estado+'\" where id_ticket_articulo='+id_ticket_articulo;
    connection.query(sql, function (err, docs) {
   		if (err) res.send(err)
   		else res.send(docs);	
	});
});

app.put("/menu_ticket", function (req,res){
	var id_ticket_menu = req.body.id_ticket_menu;
	var estado = req.body.estado;
  var id_primero = req.body.id_primero;
  var id_segundo = req.body.id_segundo;
  var id_postre = req.body.id_postre;
  var id_bebida = req.body.id_bebida;
	var sql = 'update ticket_menu set '
  if(estado){
    sql+='estado=\"'+estado+'\",';
  }
  if(id_primero){
    sql+='id_primero='+id_primero+',';
  }
  if(id_segundo){
    sql+='id_segundo='+id_segundo+',';
  }
  if(id_postre){
    sql+='id_postre='+id_postre+',';
  }
  if(id_bebida){
    sql+='id_bebida='+id_bebida+',';
  }
    sql = sql.substring(0, sql.length-1);
    sql+=' where id_ticket_menu='+id_ticket_menu;
    connection.query(sql, function (err, docs) {
   		if (err) res.send(err)
   		else res.send(docs);	
	});
});

app.put("/fotos", function (req,res){
  var id_foto = req.body.id_foto;
  var foto = req.body.foto;
  var sql = 'update foto set foto=\"'+foto+'\" where id_foto='+id_foto;
    connection.query(sql, function (err, docs) {
      if (err) res.send(err)
      else res.send(docs);  
  });
});



//Eliminar una fila de la tabla dado un id
app.delete('/usuarios/:opcional?', function (req, res) {
	if(req.params.opcional){
    var nombre_usuario = req.params.opcional.split("=")[1];
  	connection.query('delete from usuario where nombre_usuario=\"'+nombre_usuario+'\"', function (err, docs) {
     		if (err) res.send(err)
     		else res.send(docs);	
  	});
  }
});

app.delete('/tickets/:opcional?', function (req, res) {
  if(req.params.opcional){
  	var id_ticket = req.params.opcional.split("=")[1];
  	connection.query('delete from ticket where id_ticket='+id_ticket, function (err, docs) {
     		if (err) res.send(err)
     		else res.send(docs);	
  	});
  }
});

app.delete('/restaurantes/:opcional?', function (req, res) {
  if(req.params.opcional){
  	var id_restaurante = req.params.opcional.split("=")[1];
  	connection.query('delete from restaurante where id_restaurante='+id_restaurante, function (err, docs) {
     		if (err) res.send(err)
     		else res.send(docs);	
  	});
  }
});

app.delete('/mesas/:opcional?', function (req, res) {
  if(req.params.opcional){
  	var id_mesa = req.params.opcional.split("=")[1];
  	connection.query('delete from mesa where id_mesa='+id_mesa, function (err, docs) {
     		if (err) res.send(err)
     		else res.send(docs);	
  	});
  }
});

app.delete('/menus/:opcional?', function (req, res) {
  if(req.params.opcional){
  	var id_menu = req.params.opcional.split("=")[1];
  	connection.query('delete from menu where id_menu='+id_menu, function (err, docs) {
     		if (err) res.send(err)
     		else res.send(docs);		
  	});
  }
});

app.delete('/articulos/:opcional?', function (req, res) {
  if(req.params.opcional){
  	var id_articulo = req.params.opcional.split("=")[1];
  	connection.query('delete from articulo where id_articulo='+id_articulo, function (err, docs) {
     		if (err) res.send(err)
     		else res.send(docs);	
  	});
  }
});

app.delete("/articulos_ticket/:opcional?", function (req,res){
  if(req.params.opcional){
  	var id_ticket_articulo = req.params.opcional.split("=")[1];
     	connection.query('delete from ticket_articulo where id_ticket_articulo='+id_ticket_articulo, function (err, docs) {
     		if (err) res.send(err)
     		else res.send(docs);	
  	});
  }
});

app.delete("/menu_ticket/:opcional?", function (req,res){
  if(req.params.opcional){
  	var id_ticket_menu = req.params.opcional.split("=")[1];
     	connection.query('delete from ticket_menu where id_ticket_menu='+id_ticket_menu, function (err, docs) {
     		if (err) res.send(err)
     		else res.send(docs);	
  	});
  }
});

app.delete("/articulos_menu/:opcional?", function (req,res){
  if(req.params.opcional){
  	var id_menu = req.params.opcional.split("=")[1];
     	connection.query('delete from articulo_menu where id_menu='+id_menu, function (err, docs) {
     		//obtiene los articulos del menu "id"
     		if (err) res.send(err)
     		else res.send(docs);	
  	});
  }
});

app.delete("/fotos/:opcional?", function (req,res){
  if(req.params.opcional){
    var id_foto = req.params.opcional.split("=")[1];
      connection.query('delete from foto where id_foto='+id_foto, function (err, docs) {
        if (err) res.send(err)
        else res.send(docs);  
    });
  }
});

http.createServer(app).listen(app.get('port'), function (){
console.log('Express server listening on port ' + app.get('port'));
});